/*
Research Project:   Category Theory Database Tools
                    J. Bradbury, Dr. R. Rosebrugh
                    Mount Allison University 1999
File:               AddOARFrame.java
Description:	      This file is displayed when the user selects the "Add Object",
                    "Add Arrow", or "Add Relation" menu option in the main window.1
                    It displays a list of objects in categories that are presently
                    in memory. The user can select a category file(*.CAT) and chose
                    add an object, arrow, or relation.
*/

//import statements
import java.awt.*;
import borland.jbcl.layout.*;
import java.awt.event.*;
import borland.jbcl.control.*;

public class AddDataFrame extends Frame {

  Category cat = new Category();
  DefList l = new DefList();
  int check_enter = 0;
  Constants cons = new Constants();
  int MAXWORD = cons.MAXWORD;
  int MAXARR = cons.MAXARR;
  //Objects in the Graphical User Interface(GUI)
  Button exit = new Button();
  Panel button_panel = new Panel();
  BorderLayout borderLayout1 = new BorderLayout();
  XYLayout xYLayout1 = new XYLayout();
  Label label2 = new Label();
  GroupBox groupBox1 = new GroupBox();
  XYLayout xYLayout2 = new XYLayout();
  GroupBox groupBox2 = new GroupBox();
  XYLayout xYLayout3 = new XYLayout();
  TextField categoryField = new TextField();
  MainWindow edit = new MainWindow();
  TextArea statusArea = new TextArea("", 10, 10, TextArea.SCROLLBARS_VERTICAL_ONLY);
  Label label1 = new Label();
  TextField dataInputField = new TextField();
  Label dataInputLabel = new Label();
  Button doneButton = new Button();
  int submenu = 1;
  String temp = new String();

  public AddDataFrame(MainWindow ed)
  //Default Constructor with the list of categories as a parameter
  {
    edit = ed;
    try  {
      jbInit();
    }
    catch (Exception e) {
      e.printStackTrace();
    }
  }

  public boolean handleEvent(Event e)
  {
    if ((e.id == Event.WINDOW_DESTROY))
    {
     hide();            //hide frame
     dispose();         //free resources
     return true;
    }
    return super.handleEvent(e);
  }

 public boolean action(Event e, Object o)
 {
  if (e.target == exit)
  {
   hide();            //hide frame
   dispose();         //free resources
   return true;
  }
  else if (e.key == Event.ENTER)
  {
    //okButton.requestFocus();
    return(true);
  }
  return false;
 }


 private void jbInit() throws Exception
 //This function intializes the GUI
 {
    this.setTitle("GDCT: Add Data to Category");
    this.setBackground(new Color(192,192,192));
    xYLayout1.setHeight(330);
    xYLayout1.setWidth(352);
    label2.setText("Current Category:");
    this.setLayout(xYLayout1);
    groupBox2.setLayout(xYLayout3);
    groupBox1.setLayout(xYLayout2);
    categoryField.setBackground(Color.white);
    this.add(groupBox2, new XYConstraints(8, 5, 327, 56));
    groupBox2.add(label2, new XYConstraints(-1, 3, -1, 17));
    groupBox2.add(categoryField, new XYConstraints(116, 0, 169, -1));
    this.add(groupBox1, new XYConstraints(8, 63, 324, 105));
    groupBox1.add(dataInputField, new XYConstraints(116, 3, 167, -1));
    groupBox1.add(dataInputLabel, new XYConstraints(4, 6, 147, 22));
    groupBox1.add(doneButton, new XYConstraints(118, 39, 168, 30));
    this.add(statusArea, new XYConstraints(15, 187, 310, 102));
    this.add(label1, new XYConstraints(17, 166, 90, 21));

    cat = edit.cat;

    categoryField.setEditable(false);
    categoryField.setText(cat.name);
    groupBox1.setLabel("Add Data");
    groupBox1.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        groupBox1_actionPerformed(e);
      }
    });
    doneButton.setLabel("Done");
    doneButton.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        doneButton_actionPerformed(e);
      }
    });
    label1.setText("Add Status:");

    //Initialize Input GUI
    submenu = 1;
    dataInputLabel.setText("Object Name:");
    dataInputLabel.validate();
    doneButton.setLabel("Objects Complete");
    doneButton.validate();
    doneButton.setVisible(true);
    dataInputField.setVisible(true);
    dataInputLabel.setVisible(true);
    dataInputField.requestFocus();
  }

  void end()
  //This function is called when program is
  //terminated
  {
    edit.List.replaceNode(cat);
    edit.cat = cat;
    //Clear graphical display HERE
    edit.displayCategory(edit.cat);
    edit.GraphCategory(edit.graph_, edit.graphCanvas_, edit.cat);
    hide();
    dispose();
  }

  public boolean check_string(String str, Category c)
  //This function is designed to verify that all arrows in the str are
  //valid arrows of the category c. For each arrow of the string checks
  //that it exists in the category c. Returns true if this is the case
  //and false otherwise. The parameter str is the string to check and the
  //parameter c is the current category
  {
    int i;

    //for (i=0;i<c.numarr; i++)
    String[] arr = new String[MAXARR];
    int arrnum = 0;
    int prev = 0;
    //displayArea.setText(arrows);
    for (i=0;i<str.length();i++)
    {
      if ((str.charAt(i) == '*'))
      {
        arr[arrnum] =  str.substring(prev, i);
        if (check_arr(arr[arrnum], c))
        {
          new MessageDialog(this, "Error", str + " is not an arrow of " + c.name, true);
          return(false);
        }
        prev = i+1;
        arrnum++;
      }
      else if (i == (str.length()-1))
      {
        arr[arrnum] =  str.substring(prev, i+1);
        if (check_arr(arr[arrnum], c))
        {
          new MessageDialog(this, "Error", str + " is not an arrow of" + c.name, true);
          return(false);
        }
        prev = i+1;
        arrnum++;
      }
    }
    return(true);
  }



  public int[] copy_path(int dest[], int source[])
  /*
  Parameters:
        dest:   an array of integers which will be set to equal source
        source: an array of integers which is copied into dest
  Purpose:
        To copy one array of integers to another array of integers
  Design:
        Copies source into dest
  */
  {
    int i;
    int temp[] = new int [MAXWORD];
    edit.objectArea.append("path = ");
    for(i=0;i <=path_len(source);i++)
    {
      temp[i] = source[i];
      edit.objectArea.append("i = " + i + ", ");
      if (i != path_len(source))
        edit.objectArea.append(cat.arrow[source[i]] + "(" + source[i] + "), ");
    }
        edit.objectArea.append("\n");

    return(temp);
  }

 int[] string_to_path(String st, Category c)
 /*
 Parameters:
        st:     the string that we want to convert to an array of integers terminated
                by -1
        A:      a category that contains the arrows of the string
 Purpose:
        To convert a string of characters, where the characters represent arrows, into
        an array of integers, terminated by -1, where the integers represent arrows.
 Design:
        Returns an array of integers terminated by -1, and does not change the st.
 */
 {
  int i;
  int temp[] = new int [edit.cons.MAXWORD];

  if(st.length() == 0)
  {
    temp[0] = -1;
    return(temp);
  }
  else
  {
    String[] arr = new String[edit.cons.MAXARR];
    int arrnum = 0;
    int prev = 0;

    for(i=0;i<st.length();i++)
    {
      //displayArea.setText(arrows);
      if ((st.charAt(i) == '*'))
      {
        arr[arrnum] =  st.substring(prev, i);
        temp[arrnum]= arrow_number(arr[arrnum], c);
        edit.objectArea.append("arr[" + arrnum + "] = " + arr[arrnum] + "\n");
        prev = i+1;
        arrnum++;
      }
      else if (i == (st.length()-1))
      {
        arr[arrnum] =  st.substring(prev, i+1);
        temp[arrnum]= arrow_number(arr[arrnum], c);
        edit.objectArea.append("arr[" + arrnum + "] = " + arr[arrnum] + "\n");
        prev = i+1;
        arrnum++;

      }

    }
    //statusArea.appendText("STRING CHAR:" + st.charAt(i));
    edit.objectArea.append("arrnum = " + arrnum);
    temp[arrnum] = -1;
    i=0;
    while (temp[i] != -1)
    {
        edit.objectArea.append("temp[" + i + "] = " + temp[i] + "\n");
        i++;
    }
    return(temp);
  }
 }

public int path_len(int path[])
 /*
 Parameters:
        path:   an array of integers terminated by -1 which is a path
 Purpose:
        To determine the length of an array of integers terminated by -1
 Design:
        Returns the number of integers in the path, does not count -1
 */
 {
    int length = 0;
    while (path[length] != -1)
    {
      length++;
    }
    return(length);
 }

 public boolean check_arr(String arr, Category c)
 /*
 Parameters:
        arr:    the name of the arrow being checked
        A  :    the category
 Purpose:
        To determine whether an arrow is in the category
 Design:
        Returns false if the arrow is in the category and true if it is not
 */
 {
  int i;
  String temp = new String();
  for(i=0;i< c.numarr;i++)
  {
    if(arr.equals(c.arrow[i]))
    {
      return(false);
    }
  }
  return(true);
}

   public int arrow_number(String name, Category c)
 {
  int i;

  for(i=0;i < c.numarr;i++)
  {
    if(c.arrow[i].equals(name))
    {
      edit.objectArea.append("Arrow Num: " + i + "(" + c.arrow[i] + ")\n");
                 return(i);
        }
  }
  return(-1);
 }

  void cancelButton_actionPerformed(ActionEvent e) {
    hide();
    dispose();
  }

  void doneButton_actionPerformed(ActionEvent e)
  {
    if (submenu == 1)
    {
      dataInputLabel.setText("Arrow Name:");
      dataInputLabel.validate();
      doneButton.setLabel("Arrows Complete");
      doneButton.validate();
      submenu = 2;
    }
    else if (submenu == 2)
    {
      submenu = 5;
      dataInputLabel.setText("LHS of Equation:");
      dataInputLabel.validate();
      doneButton.setLabel("Relations Complete");
      doneButton.validate();
    }
    else if (submenu == 5 || submenu ==6)
    {
      end();
    }
  }

  public void CatMenuEnter(Event e)
  //Method is called when user is in category Menu and
  //hasa pressed the enter button
  {
    int check = 0;
    if (submenu == 1)
    {
      String temp = dataInputField.getText();
      for (int i = 0; i < cat.numobj; i++)
      {
        if (temp.equals(cat.obj[i]))
          check = 1;
      }
      if ((check == 0))
      {
        statusArea.append("Object: " + dataInputField.getText() + "\n");
        dataInputField.setText("");
        dataInputField.requestFocus();
        cat.obj[cat.numobj] = temp;
        cat.numobj++;
        /*if (cat.numobj == 1)
          GraphCategory(graph_, graphCanvas_, cat);
        else
        {
          graphCanvas_.unselectItems();
          GraphEdit ge = new GraphEdit(graph_, graphCanvas_);
          cat.gml = ge.getGMLText();
          ge.dispose();
          addObjectGML(cat.gml);
          boolean test = displayCategory(cat.gml);
        } */
      }
      else
      {
        new MessageDialog(this, "Error", "Multiple declaration of object " + temp, true);
      }
      dataInputField.requestFocus();
      dataInputLabel.setText("Object Name:");
      dataInputLabel.validate();
    }
    else if (submenu == 2)
    {
      String temp = dataInputField.getText();
      //workbox.setText("");
      for (int i = 0; i < cat.numarr; i++)
      {
        if (temp.equals(cat.arrow[i]))
          check = 1;
      }
      if (check == 0)
      {
        statusArea.append(" Arrow: " + dataInputField.getText());
        dataInputField.setText("");
        cat.arrow[cat.numarr] = temp;
        submenu = 3;
        dataInputLabel.setText("Domain of " + cat.arrow[cat.numarr] + ": ");
        dataInputLabel.validate();
        dataInputField.requestFocus();
      }
      else
      {
        new MessageDialog(this, "Error", "Multiple declaration of arrow " + temp, true);
      }
    }
    else if ((submenu == 3) && (cat.numobj != 0))
    {
      String temp = dataInputField.getText();
      for (int i = 0; i < cat.numobj; i++)
      {
        if (cat.obj[i].equals(temp))
        {
          check = 1;
          cat.arr[cat.numarr][0] = i;
        }
      }
      if (check == 1)
      {
        statusArea.append(":" + dataInputField.getText() + "->");
        dataInputField.setText("");
        submenu = 4;
        dataInputLabel.setText("CoDomain of " + cat.arrow[cat.numarr] + ": ");
        dataInputLabel.validate();
        dataInputField.requestFocus();
      }
      else
      {
        new MessageDialog(this, "Error", "Invalid Domain Declaration. Domain " + temp + " Not Found", true);
        dataInputLabel.setText("Domain of " + cat.arrow[cat.numarr] + ": ");
        dataInputLabel.validate();
      }
    }
    else if (submenu == 4)
    {
      String temp = dataInputField.getText();
      for (int i = 0; i < cat.numobj; i++)
      {
        if (cat.obj[i].equals(temp))
        {
          check = 1;
          cat.arr[cat.numarr][1] = i;
        }
      }
      if (check == 1)
      {
        statusArea.append(dataInputField.getText() + "\n");
        dataInputField.setText("");
        cat.numarr++;
      /*  graphCanvas_.unselectItems();
        GraphEdit ge = new GraphEdit(graph_, graphCanvas_);
        cat.gml = ge.getGMLText();
        ge.dispose();
        addArrowGML(cat.gml, (cat.numarr)-1);
        boolean test = displayCategory(cat.gml);*/
        dataInputField.requestFocus();
        dataInputLabel.setText("Arrow Name: ");
        dataInputLabel.validate();
        submenu = 2;
      }
      else
      {
        new MessageDialog(this, "Error", "Invalid CoDomain Declaration. CoDomain " + temp + " Not Found", true);
        dataInputLabel.setText("CoDomain of " + cat.arrow[cat.numarr] + ": ");
        dataInputLabel.validate();
      }
    }
    else if (submenu == 5)
    {
      temp = dataInputField.getText();
      statusArea.append("Relation: " + temp + " = ");
      dataInputField.setText("");
      submenu = 6;
      dataInputLabel.setText("RHS of equation :");
      dataInputLabel.validate();
      dataInputField.requestFocus();
    }
    else if (submenu == 6)
    {
      statusArea.append(dataInputField.getText() + "\n");
      edit.get_rel(temp, dataInputField.getText(), cat);
      dataInputField.setText("");
      submenu = 5;
      dataInputLabel.setText("LHS of equation :");
      dataInputLabel.validate();
    }
  }

  public boolean keyDown(Event e, int key)
  {
    if (e.key == Event.ENTER)
    {
      CatMenuEnter(e);
    }
    return (false);
  }

  void groupBox1_actionPerformed(ActionEvent e) {

  }
}




