/*
Research Project:   Category Theory Database Tools
                    J. Bradbury, Dr. R. Rosebrugh
                    Mount Allison University 1998
File:               Category.java
Description:	      This class is equivalent to a struct in C/C++. It contains all
                    of the information that is needed for a category
*/

class Category
{
  Constants c = new Constants();        //Constant class that contains the lengths
                                        //of the arrays in the Category class
  String name;                          //Name of the category

  String[] obj = new String[c.MAXWORD]; //Names of the objects in the category
  int numobj =0;                        //Number of objects in category

  int[][] arr = new int[c.MAXARR][2];   //domain and codomain of arrows
  String[] arrow = new String[c.MAXARR];//Names of arrows in a category
  int numarr = 0;                       //Number of arrows in category

  Relation[] rel_set = new Relation[c.MAXARR];  //Contains relations in category
  int num_rel = 0;                      //Number of relations in category

  String comment = new String();        //Comments about the category
  String filename = new String();       //Name of file that category was opened,
                                        //loaded, or saved in
  String gml = new String();            //Text version of graphical interpretation
                                        //of category
}


