/*
Research Project:   Category Theory Database Tools
                    J. Bradbury, Dr. R. Rosebrugh
                    Mount Allison University 1999
File:               ChangeNameFrame.java
Description:	      This file is displayed when the user selects the "Change
                    Name of Category" menu option in the main window. The user
                    can select a category file(*.CAT) from a choice menu and then
                    enter a new name in the text field below it.
*/

//import statements
import java.awt.*;
import borland.jbcl.layout.*;
import java.awt.event.*;
import borland.jbcl.control.*;

public class ChangeNameFrame extends Frame {

  Category c = new Category();
  DefList l = new DefList();
  int check_enter = 0;

  //Objects in the Graphical User Interface(GUI)
  Button exit = new Button();
  Panel button_panel = new Panel();
  BorderLayout borderLayout1 = new BorderLayout();
  XYLayout xYLayout1 = new XYLayout();
  Button okButton = new Button();
  Button cancelButton = new Button();
  Label label2 = new Label();
  Label label1 = new Label();
  TextField newNameField = new TextField();
  TextField currNameField = new TextField();
  MainWindow edit = new MainWindow();

  public ChangeNameFrame(DefList ltemp, MainWindow ed)
  //Default Constructor with the list of categories as a parameter
  {
    l = ltemp;
    edit = ed;
    try  {
      jbInit();
    }
    catch (Exception e) {
      e.printStackTrace();
    }
  }

  public boolean handleEvent(Event e)
  {
    if ((e.id == Event.WINDOW_DESTROY) || (e.id == Event.ACTION_EVENT))
    {
     hide();            //hide frame
     dispose();         //free resources
     return true;
    }
    else if (e.key == Event.ENTER)
    {
      if (check_enter == 0)
       check_enter++;
      else
      {
       hide();            //hide frame
       dispose();         //free resources
      }
      return true;
    }
    return super.handleEvent(e);
  }

 public boolean action(Event e, Object o)
 {
  if ((e.target == exit) || (e.key == Event.ENTER))
  {
   hide();            //hide frame
   dispose();         //free resources
   return true;
  }
  return false;
 }


 private void jbInit() throws Exception
 //This function intializes the GUI
 {
    this.setTitle("CTDT: Change Category Name");
    this.setBackground(new Color(192,192,192));
    xYLayout1.setHeight(150);
    okButton.setLabel("OK");
    xYLayout1.setWidth(339);
    okButton.setLabel("OK");
    okButton.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        okButton_actionPerformed(e);
      }
    });
    cancelButton.setLabel("cancel");
    label2.setText("Current Category Name:");
    label1.setText("New Category Name:");
    this.setLayout(xYLayout1);
    currNameField.setBackground(Color.white);
    this.add(okButton, new XYConstraints(18, 80, 145, 31));
    this.add(cancelButton, new XYConstraints(171, 79, 145, 31));
    this.add(label2, new XYConstraints(17, 10, -1, -1));
    this.add(label1, new XYConstraints(16, 43, -1, -1));
    this.add(newNameField, new XYConstraints(170, 40, 145, 24));
    this.add(currNameField, new XYConstraints(170, 8, 145, -1));
    ListNode current = l.head;
    currNameField.setEditable(false);
    currNameField.setText(edit.categoryChoice.getSelectedItem());
    String name = edit.categoryChoice.getSelectedItem();
    c = l.getNode(name);
    newNameField.setBackground(Color.white);
  }

  void okButton_actionPerformed(ActionEvent e)
  //Function called when OK button is pressed. This function
  //take the string in the nameField and makes it the name of
  //the current category
  {
    if (newNameField.getText().equals(""))
    {
        new MessageDialog(this, "Error", "New category name must be filled in before it can replace existing category name", true);
    }
    else
    {
      c.name = newNameField.getText();
      l.replaceNode(c);
      edit.categoryChoice.remove(edit.categoryChoice.getSelectedItem());
      edit.categoryChoice.add(c.name);
      edit.categoryChoice.select(c.name);
      hide();
      dispose();
    }
  }
}
