/*
Research Project:   Category Theory Database Tools
                    J. Bradbury, Dr. R. Rosebrugh
                    Mount Allison University 1998
File:               Constants.java
Description:	      This class contains the global constants that
*/

//import statements
import java.awt.Color;

public class Constants
{
  int maxloop = 15;       //The Max Order of Endomorphisms is set to 2 by default
  int MAXWORD = 50;      //MAXWORD is set to 50 by default
  int MAXARR = 50;       //MAXARR is set to 50 by default
  char separator = '*';  //seperator is the character that is used to seperate
                         //arrow names in a path or relation
  String dot = "*";      //This is the unicode character for composition that will be
                         //displayed in the program instead of the *
  int id_code = -2;      //This value is the integer representation of an identity
                         //arrow

  //The default server that examply categories and functors are located on.
  //catdir specifies the directory of categories while funcdir specifies the
  //directory of functors
  String server = "http://cs.mta.ca/research/rosebrugh/gdct/";
  String catdir = "cat/";
  String cgldir = "cgl/";
  String fundir = "fun/";
  String fgldir = "fgl/";

  int animation_delay = 2000;             //animation delay time in ms
  Color AColor = Color.red;               //animated color of objects
                                          //and arrows in category A
  Color BColor = Color.red;               //animated color of objects
                                          //and arrows in category B


}
