/*
Research Project:   Category Theory Database Tools
                    J. Bradbury, Dr. R. Rosebrugh
                    Mount Allison University 1998
File:               Dialog1.java
Description:	      This class displays a dialog box that prompts the user
                    for a new name if the name of the category file being loaded,
                    created, or opened already exists in the open categories list.
*/


//import statements
import java.awt.*;
import java.awt.event.*;
import borland.jbcl.layout.*;
import borland.jbcl.control.*;

public class Dialog1 extends Dialog {
  Panel panel1 = new Panel();
  Label label1 = new Label();
  XYLayout xYLayout1 = new XYLayout();
  Label label2 = new Label();
  TextField nameField = new TextField();
  Button okButton = new Button();
  MainWindow edit = new MainWindow();
  Category cat = new Category();


  public Dialog1(Frame frame, String title, boolean modal, MainWindow ed, Category c) {
    super(frame, title, modal);
    edit = ed;
    cat = c;
    enableEvents(AWTEvent.WINDOW_EVENT_MASK);
    try  {
      jbInit();
      add(panel1);
      pack();
    }
    catch (Exception ex) {
      ex.printStackTrace();
    }
	  pack();

        //Determine center position for dialog on screen
    Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
    Dimension frameSize = this.getSize();
    if (frameSize.height > screenSize.height)
      frameSize.height = screenSize.height;
    if (frameSize.width > screenSize.width)
      frameSize.width = screenSize.width;
    this.setLocation((screenSize.width - frameSize.width) / 2, (screenSize.height - frameSize.height) / 2);

	  show();
  }

  void jbInit() throws Exception {
    label2.setText("Enter a new category name:");
    okButton.setLabel("OK");
    okButton.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        okButton_actionPerformed(e);
      }
    });
    label1.setText("Current category name is already in use by another category");
    xYLayout1.setHeight(118);
    xYLayout1.setWidth(363);
    panel1.setLayout(xYLayout1);
    panel1.add(label2, new XYConstraints(14, 38, 160, 20));
    panel1.add(nameField, new XYConstraints(177, 37, 167, -1));
    panel1.add(okButton, new XYConstraints(140, 72, 106, 31));
    panel1.add(label1, new XYConstraints(15, 9, 345, -1));
  }

  protected void processWindowEvent(WindowEvent e) {
    /*if (e.getID() == WindowEvent.WINDOW_CLOSING) {
      cancel();
    } */
    super.processWindowEvent(e);
  }

  void cancel() {
    dispose();
  }

  void okButton_actionPerformed(ActionEvent e)
  //This occurs when a new name is entered
  {
    boolean name = false;   //true is name already exists, false otherwise
    ListNode current = edit.List.head;

    if (!nameField.getText().equals(""))
    {
      while(current != null)
      {
        if (current.cat.name.equals(nameField.getText()))
          name = true;
        current = current.next;
      }
      if (name == true)
      {
        nameField.setText("");
      }
      else
      {
        cat.name = nameField.getText();
        dispose();
        hide();
      }
    }
  }

  void cancelButton_actionPerformed(ActionEvent e)
  {
     dispose();
     hide();
  }
}


