 /*
Research Project:   Category Theory Database Tools
                    J. Bradbury, Dr. R. Rosebrugh
                    Mount Allison University 1999
File:               EndomorphismFrame.java
Description:	      This file is displayed when the user selects the "Change Maximum
                    Order of Endomorphism". It allows the user to select a new
                    maximum order of endomorphism to replace the default of 2
*/

//import statements
import java.awt.*;
import borland.jbcl.layout.*;
import java.awt.event.*;
import borland.jbcl.control.*;

public class EndomorphismFrame extends Frame {

  Category c = new Category();
  DefList l = new DefList();
  int check_enter = 0;

  //Objects in the Graphical User Interface(GUI)
  Button exit = new Button();
  Panel button_panel = new Panel();
  BorderLayout borderLayout1 = new BorderLayout();
  XYLayout xYLayout1 = new XYLayout();
  Button okButton = new Button();
  Button cancelButton = new Button();
  GroupBox scaleBox = new GroupBox();
  CheckboxGroup orderGroup = new CheckboxGroup();
  Checkbox orderOne = new Checkbox("Order 1", orderGroup, false);
  Checkbox orderOther = new Checkbox("Order = ", orderGroup, false);
  Checkbox orderThree = new Checkbox("Order 3", orderGroup, false);
  Checkbox orderTwo = new Checkbox("Order 2", orderGroup, false);
  XYLayout xYLayout5 = new XYLayout();
  TextField orderField = new TextField();
  MainWindow ed = new MainWindow();
  Checkbox orderFour = new Checkbox("Order 4", orderGroup, false);
  Checkbox orderFive = new Checkbox("Order 5", orderGroup, false);
  Label label1 = new Label();
  Label label2 = new Label();



  public EndomorphismFrame(MainWindow edit)
  //Default Constructor with the list of categories as a parameter
  {
    ed = edit;
    //l = ltemp;
    try  {
      jbInit();
    }
    catch (Exception e) {
      e.printStackTrace();
    }
  }

  public boolean handleEvent(Event e)
  {
    if (e.id == Event.WINDOW_DESTROY)
    {
     hide();            //hide frame
     dispose();         //free resources
     return true;
    }
    else if (e.key == Event.ENTER)
    {
      if (check_enter == 0)
       check_enter++;
      else
      {
       hide();            //hide frame
       dispose();         //free resources
      }
      return true;
    }
    else if (e.target instanceof Choice)
    {
      return (true);
    }
    else
      return super.handleEvent(e);
  }

 public boolean action(Event e, Object o)
 {
  if ((e.target == exit) || (e.key == Event.ENTER))
  {
   hide();            //hide frame
   dispose();         //free resources
   return true;
  }
  return false;
 }


 private void jbInit() throws Exception
 //This function intializes the GUI
 {
    this.setTitle("GDCT: Endomorphism Order");
    this.setBackground(new Color(192,192,192));
    xYLayout1.setHeight(298);
    okButton.setLabel("OK");
    xYLayout1.setWidth(258);

    okButton.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        okButton_actionPerformed(e);
      }
    });
    cancelButton.setLabel("cancel");
    orderField.setBackground(Color.white);
    cancelButton.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        cancelButton_actionPerformed(e);
      }
    });
    orderFour.setLabel("Order 4");
    orderFive.setLabel("Order 5");
    label1.setText("Current Order: " + ed.cons.maxloop);
    label2.setText("New Order:");
    this.setLayout(xYLayout1);
    scaleBox.setLayout(xYLayout5);
    this.add(okButton, new XYConstraints(15, 224, 100, 31));
    this.add(cancelButton, new XYConstraints(130, 224, 103, 31));
    this.add(scaleBox, new XYConstraints(10, 18, 229, 203));
    scaleBox.add(orderOne, new XYConstraints(88, 35, -1, -1));
    scaleBox.add(orderOther, new XYConstraints(88, 152, 65, -1));
    scaleBox.add(orderThree, new XYConstraints(88, 82, -1, -1));
    scaleBox.add(orderTwo, new XYConstraints(88, 58, -1, -1));
    scaleBox.add(orderField, new XYConstraints(152, 152, 43, -1));
    scaleBox.add(orderFour, new XYConstraints(88, 106, -1, -1));
    scaleBox.add(orderFive, new XYConstraints(88, 129, -1, -1));
    scaleBox.add(label1, new XYConstraints(2, 7, 179, -1));
    scaleBox.add(label2, new XYConstraints(3, 35, -1, -1));
    orderTwo.setLabel("Order 2");
    orderThree.setLabel("Order 3");
    orderOther.setLabel("Order = ");
    orderOne.setLabel("Order 1");
    scaleBox.setLabel("Max Order of Endomorphism:");
    selectTrueBox();
 }

  void selectTrueBox()
  //Determines which check box is true when window is opened
  {
    if (ed.cons.maxloop == 1)
      orderGroup.setSelectedCheckbox(orderOne);
    else if (ed.cons.maxloop == 2)
      orderGroup.setSelectedCheckbox(orderTwo);
    else if (ed.cons.maxloop == 3)
      orderGroup.setSelectedCheckbox(orderThree);
    else if (ed.cons.maxloop == 4)
      orderGroup.setSelectedCheckbox(orderFour);
    else if (ed.cons.maxloop == 5)
      orderGroup.setSelectedCheckbox(orderFive);
    else
    {
      orderGroup.setSelectedCheckbox(orderOther);
      orderField.setText("" + ed.cons.maxloop);
    }
  }

  void okButton_actionPerformed(ActionEvent e)
  //Function called when OK button is pressed
  {
    Checkbox selected = orderGroup.getCurrent();
    String label = selected.getLabel();
    if(label.equals("Order 1"))
      ed.cons.maxloop  = 1;
    else if(label.equals("Order 2"))
      ed.cons.maxloop  = 2;
    else if(label.equals("Order 3"))
      ed.cons.maxloop  = 3;
    else if(label.equals("Order 4"))
      ed.cons.maxloop  = 4;
    else if(label.equals("Order 5"))
      ed.cons.maxloop  = 5;
    else
    {
      try
      {
        ed.cons.maxloop  = Integer.parseInt(orderField.getText());
      }
      catch (NumberFormatException e1)
      {
        new MessageDialog(this, "Error", "Endomorphism value must be an integer", true);
      }
    }
    hide();
    dispose();
  }

  void cancelButton_actionPerformed(ActionEvent e) {
    hide();
    dispose();
  }

}
