/*
Research Project:   Category Theory Database Tools
                    J. Bradbury, Dr. R. Rosebrugh
                    Mount Allison University 1999
File:               EqualityComposites.java
Description:        This class implements a frame that tests paths in a given
                    category for equality
*/

//import statements
import java.awt.*;
import borland.jbcl.layout.*;
import java.awt.event.*;
import borland.jbcl.control.*;

public class EqualityComposites extends Frame {

  Category cat = new Category();
  DefList l = new DefList();
  int check_enter = 0;

  //Objects in the Graphical User Interface(GUI)
  Button exit = new Button();
  Panel button_panel = new Panel();
  BorderLayout borderLayout1 = new BorderLayout();
  XYLayout xYLayout1 = new XYLayout();
  Button equalityButton = new Button();
  Button okButton = new Button();
  Label label2 = new Label();
  Label label1 = new Label();
  TextField path1Field = new TextField();
  TextField categoryName = new TextField();
  MainWindow edit = new MainWindow();
  Label label3 = new Label();
  TextField path2Field = new TextField();
  GroupBox groupBox1 = new GroupBox();
  Label label4 = new Label();
  TextArea resultArea  = new TextArea("", 10, 10, TextArea.SCROLLBARS_VERTICAL_ONLY);
  Constants cons = new Constants();
  int p1[] = new int[cons.MAXWORD];
  int p2[] = new int[cons.MAXWORD];
  int redp1[] = new int[cons.MAXWORD];
  int redp2[] = new int[cons.MAXWORD];
  String path1 = new String();
  String path2 = new String();

  public EqualityComposites(DefList ltemp, MainWindow ed)
  //Default Constructor with the list of categories as a parameter
  {
    l = ltemp;
    edit = ed;
    try  {
      jbInit();
    }
    catch (Exception e) {
      e.printStackTrace();
    }
  }

  public boolean handleEvent(Event e)
  {
    if ((e.id == Event.WINDOW_DESTROY) || (e.id == Event.ACTION_EVENT))
    {
     hide();            //hide frame
     dispose();         //free resources
     return true;
    }
    else if (e.key == Event.ENTER)
    {
      if (check_enter == 0)
       check_enter++;
      else
      {
       hide();            //hide frame
       dispose();         //free resources
      }
      return true;
    }
    return super.handleEvent(e);
  }

 public boolean action(Event e, Object o)
 {
  if ((e.target == exit) || (e.key == Event.ENTER))
  {
   hide();            //hide frame
   dispose();         //free resources
   return true;
  }
  return false;
 }


 private void jbInit() throws Exception
 //This function intializes the GUI
 {
    this.setTitle("GDCT: Equality of Composites");
    this.setBackground(new Color(192,192,192));
    xYLayout1.setHeight(175);
    equalityButton.setLabel("OK");
    xYLayout1.setWidth(531);
    equalityButton.setLabel("Equality ?");
    equalityButton.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        equalityButton_actionPerformed(e);
      }
    });
    okButton.setLabel("OK");
    label2.setText("Category Name:");
    label1.setText("First Path:");
    this.setLayout(xYLayout1);
    resultArea.setBackground(Color.white);
    categoryName.setBackground(Color.white);
    this.add(equalityButton, new XYConstraints(217, 108, 145, 31));
    this.add(okButton, new XYConstraints(371, 108, 145, 31));
    this.add(label2, new XYConstraints(12, 10, 95, -1));
    this.add(label1, new XYConstraints(13, 43, -1, -1));
    this.add(path1Field, new XYConstraints(113, 40, 145, 24));
    this.add(categoryName, new XYConstraints(113, 9, 145, -1));
    this.add(label3, new XYConstraints(12, 77, -1, -1));
    this.add(path2Field, new XYConstraints(112, 75, 146, -1));
    this.add(groupBox1, new XYConstraints(267, 1, 8, 104));
    this.add(label4, new XYConstraints(285, 9, 52, 21));
    this.add(resultArea, new XYConstraints(286, 31, 231, 65));
    ListNode current = l.head;
    categoryName.setEditable(false);
    categoryName.setText(edit.categoryChoice.getSelectedItem());
    String name = edit.categoryChoice.getSelectedItem();
    cat = l.getNode(name);
    path2Field.setBackground(Color.white);
    path1Field.setBackground(Color.white);
    label4.setText("Results:");
    label3.setText("Second Path:");
    resultArea.setEditable(false);
  }

  void equalityButton_actionPerformed(ActionEvent e)
  //Function called when OK button is pressed.
  {
    equality_test();
  }

  void equality_test()
  {
    boolean success = false;
    /*
    //while (!success)
		//{
		  //success = true;
		  //clearscreen();
		  //print_c(A,stdout);
		  //printf("\n\n");
		  if (ask_for_paths(p1,p2,A))
		  {
			  if ((p1[0] == -2) || (p2[0] == -2))
				  return;
			}
		  else
		 	{
			  if ((p1[0] == -2) || (p2[0] == -2))
				{
			  	success = false;
		  		//printf("\nHit <enter> to continue.");
		  		//flush();
			  	//getchar();
		  	}
			}
    }
	  if ((p1[0] == -2) || (p2[0] == -2))
		  return;*/
    //If paths p1 and p2 are valid paths
    if (ask_for_paths())
    {
  	  redp1 = reduce(redp1, p1, cat);
	    redp2 = reduce(redp2, p2, cat);
  	  if ((equals(redp1, redp2)) && ((cat.arr[p1[0]][1] == cat.arr[p2[0]][1]) || (p1[0] == -1) || (p2[0] == -1)))
		  {
		    resultArea.append(path1 + " and " + path2 + " are equal.\n");
      }
	    else
		  {
		    resultArea.append(path1 + " and " + path2 + " are NOT equal.\n");
      }
    }
  }

  boolean ask_for_paths()
  //This method reads in the two paths from path1Field and path2Field that
  //have been entered by the user and converts them to arrays of integers
  //terminated by -1 and then stores them in p1 and p2.
  {
    String first = new String();  //path 1 string
    String second = new String(); //path 2 string

    //Intitialize paths to -2 which means invalid
    p1[0] = p2[0] = -2;

    //Get First Path
    path1 = first = path1Field.getText();
    path1Field.setText("");

    //Check First Path for Valid Arrows
    if (check_string(first, cat))
    {
      //Convert path string to path of integers
      p1 = string_to_path(first, cat);
      //for (int i = 0; i < 5 ; i++)
      //  resultArea.append("p1[" + i + "] = " + p1[i] + "\n");

      //copy_path(p1, string_to_path(first, A));
      //Check path for valid domains and codomains
	    if (!check_path(p1,cat))
		  {
		    p1[0] = -2;
		    return(false);
		  }

      //Get Second Path
      path2 = second = path2Field.getText();
      path2Field.setText("");

      //Check Second Path for Valid Arrows
      if (check_string(second, cat))
      {
	      //Convert path string to path of integers
        p2 = string_to_path(second, cat);

        //copy_path(p2, string_to_path(second, A));
    	  //Check path for valid domains and codomains
	      if (!check_path(p2,cat))
  		  {
	      	p2[0] = -2;
		      return(false);
		    }
      }
    }
    if ((p1[0] == -2) || (p2[0] == -2))
      return(false);
    return(true);
  }

  public int[] copy_path(int dest[], int source[])
  /*
  Parameters:
        dest:   an array of integers which will be set to equal source
        source: an array of integers which is copied into dest
  Purpose:
        To copy one array of integers to another array of integers
  Design:
        Copies source into dest
  */
  {
    int i;
    int temp[] = new int [cons.MAXWORD];
    //objectArea.append("path = ");
    for(i=0;i <=path_len(source);i++)
    {
      temp[i] = source[i];
      //objectArea.append("i = " + i + ", ");
      //if (i != path_len(source))
       //objectArea.append(cat.arrow[source[i]] + "(" + source[i] + "), ");
    }
        //objectArea.append("\n");

    return(temp);
  }


  public String path_to_string(int path[], Category A)
  /*
  Parameters:
        path:   the path to be converted to a string(function does not change
                         path)
        A:              a category that contains the arrows of the path
  Purpose:
        To convert an array of integers, which represent arrows, terminated by -1
        into a path which is a string of characters which are arrows and the string
        is terminated by \0.
  Design:
        Returns a string which is the path represented by the integers in the
        integer array
  */
  {
    int i;
    String temp = new String();

    if ((path[0] == cons.id_code))
    {
      return("1");
    }
    else
    {
      for(i=0;i<path_len(path);i++)
      {
        if (i < path_len(path)-1)
  		    temp = temp + A.arrow[path[i]] + "*";
        else
  		    temp = temp + A.arrow[path[i]];
      }
      temp = temp + '\0';
      return(temp);
    }
    //return ("NOT 1");
  }

 int[] string_to_path(String st, Category c)
 /*
 Parameters:
        st:     the string that we want to convert to an array of integers terminated
                by -1
        A:      a category that contains the arrows of the string
 Purpose:
        To convert a string of characters, where the characters represent arrows, into
        an array of integers, terminated by -1, where the integers represent arrows.
 Design:
        Returns an array of integers terminated by -1, and does not change the st.
 */
 {
  int i;
  int temp[] = new int [cons.MAXWORD];

  if(st.length() == 0)
  {
    temp[0] = -1;
    return(temp);
  }
  else
  {
    String[] arr = new String[cons.MAXARR];
    int arrnum = 0;
    int prev = 0;

    for(i=0;i<st.length();i++)
    {
      //displayArea.setText(arrows);
      if ((st.charAt(i) == '*'))
      {
        arr[arrnum] =  st.substring(prev, i);
        temp[arrnum]= arrow_number(arr[arrnum], c);
        prev = i+1;
        arrnum++;
      }
      else if (i == (st.length()-1))
      {
        arr[arrnum] =  st.substring(prev, i+1);
        temp[arrnum]= arrow_number(arr[arrnum], c);
        prev = i+1;
        arrnum++;
      }
    }
    //viewbox.append("STRING CHAR:" + st.charAt(i));
    //objectArea.append("arrnum = " + arrnum);
    temp[arrnum] = -1;

    i=0;
    while (temp[i] != -1)
    {
        //objectArea.append("temp[" + i + "] = " + temp[i] + "\n");
        i++;
    }
    return(temp);
  }
 }

  public int path_len(int path[])
  /*
  Parameters:
        path:   an array of integers terminated by -1 which is a path
  Purpose:
        To determine the length of an array of integers terminated by -1
  Design:
        Returns the number of integers in the path, does not count -1
  */
  {
    //length of path
    int length = 0;

    while (path[length] != -1)
    {
      length++;
    }
    return(length);
  }


  public int[] reduce(int reducedpath[], int path[], Category c)
  /*
  Parameters:
    reducedpath:  an array of integers which will be set to equal the
                  reduced path
    path:         the array of integers being reduced
    A:            a category
  Purpose:
    To reduce a path using the set of relations stored in a category
  Design:
    Reduces path and stores its reduced form in reducedpath
  */
  {
    int i,j;
    //the spot where the left side of a relation begins in the path being reduced
    int spot;
    //a temporary variable used to store the length of a path
    int temp;
    //the difference in length between the left side of
    //a relation and the right side of the relation
    int diff;

    reducedpath = copy_path(reducedpath,path);
    for (i=0;i<c.num_rel;i++)
    {
      if((spot = search(c.rel_set[i].lhs,reducedpath,0)) != -1)
      {
        //resultArea.append("reducedpath = " + path_to_string(reducedpath, cat) + "\n");
        for (j=spot;j<spot+path_len(c.rel_set[i].rhs);j++)
        {
          reducedpath[j] = c.rel_set[i].rhs[j - spot];
        }
        //viewbox.appendText("reducedpath[i] = " + reducedpath[i]  + "\n");
        temp = path_len(reducedpath);
        diff = path_len(c.rel_set[i].lhs) - path_len(c.rel_set[i].rhs);
        //resultArea.append("spot = " + spot + ", j = " +  (spot+path_len(c.rel_set[i].lhs)) + ", diff = " + diff + "\n");
        for (j=spot+path_len(c.rel_set[i].lhs); j < temp;j++)
        {
          reducedpath[j - diff] = reducedpath[j];
        }
        reducedpath[j - diff] = -1;
        //resultArea.append("-1 reducedpath = " + path_to_string(reducedpath, cat) + "\n");
        //resultArea.append("c.rel_set[i].lhs = " + path_to_string(c.rel_set[i].lhs, cat) + "\n");
        //resultArea.append("c.rel_set[i].rhs = " + path_to_string(c.rel_set[i].rhs, cat) + "\n");
        i = -1;
      }
    }
    return(reducedpath);
  }

  public boolean equals(int path1[], int path2[])
  /*
  Parameters:
        path1:  an array of integers terminated by -1 which is a path
        path2:  an array of integers terminated by -1 which is a path
  Purpose:
        To determine if two paths are identical
  Design:
        Returns true if path1 is identical to path2 and false otherwise
                note:this function does not reduce them at all
  */
  {
    int i;

    //Remove identity arrows in path1 if path1 != "1" itself
    if ((path_len(path1) != 1))
    {
      i  = 0;
      while (path1[i] != -1)
      {
        if (path1[i] == cons.id_code)
          for (int j = i; j < (path_len(path1)); j++)
            path1[j] = path1[j+1];
        i++;
      }
    }
    //Remove identity arrows in path2 if path2 != "1" itself
    if ((path_len(path2) != 1))
    {
      i = 0;
      while (path2[i] != -1)
      {
        if (path2[i] == cons.id_code)
          for (int j = i; j < (path_len(path2)); j++)
            path2[j] = path2[j+1];
        i++;
      }
    }

    i = 0;
    if((path_len(path1)) == (path_len(path2)))
    {
      for(i=0;i<path_len(path1);i++)
      {
        if(path1[i] != path2[i])
        {
          return(false);
        }
      }
      return(true);
    }
    else
    {
      return(false);
    }
  }


   public boolean check_string(String str, Category c)
  //This function is designed to verify that all arrows in the str are
  //valid arrows of the category c. For each arrow of the string checks
  //that it exists in the category c. Returns true if this is the case
  //and false otherwise. The parameter str is the string to check and the
  //parameter c is the current category
  {
    int i;

    //for (i=0;i<c.numarr; i++)
    String[] arr = new String[cons.MAXARR];
    int arrnum = 0;
    int prev = 0;
    //displayArea.setText(arrows);
    for (i=0;i<str.length();i++)
    {
      if ((str.charAt(i) == '*'))
      {
        arr[arrnum] =  str.substring(prev, i);
        if (check_arr(arr[arrnum], c))
        {
          new MessageDialog(this, "Error", str + " is not an arrow of " + c.name, true);
          return(false);
        }
        prev = i+1;
        arrnum++;
      }
      else if (i == (str.length()-1))
      {
        arr[arrnum] =  str.substring(prev, i+1);
        if (check_arr(arr[arrnum], c))
        {
          new MessageDialog(this, "Error", str + " is not an arrow of " + c.name, true);
          return(false);
        }
        prev = i+1;
        arrnum++;
      }
    }
    return(true);
  }

    boolean check_path(int path[], Category A)
  //Checks that all the domains and codomains of the arrows in
  //the path match up and returns true if this is the case and false
  //otherwise
  {
    int i,arr,nextarr;

	  for (i=0;i<(path_len(path)-1);i++)
	  {
		  arr = path[i];
		  nextarr = path[i+1];
		  if ((A.arr[arr][0]) != (A.arr[nextarr][1]))
      {
   		  new MessageDialog(this, "Error", "Invalid Composition. Domain of " + A.arrow[arr] + " does not equal Codomain of " + A.arrow[nextarr], true);
			  return(false);
      }
		}
	  return(true);
  }

  public boolean check_arr(String arr, Category c)
 /*
 Parameters:
        arr:    the name of the arrow being checked
        A  :    the category
 Purpose:
        To determine whether an arrow is in the category
 Design:
        Returns false if the arrow is in the category and true if it is not
 */
 {
  int i;
  String temp = new String();

  for(i=0;i< c.numarr;i++)
  {
    if(arr.equals(c.arrow[i]))
    {
      //new MessageDialog(this, "Error", "?" + arr + " = " + c.arrow[i], true);
      return(false);
    }
  }
  return(true);
 }



  public int arrow_number(String name, Category c)
 {
  int i;

  for(i=0;i < c.numarr;i++)
  {
    if(c.arrow[i].equals(name))
    {
      //objectArea.append("Arrow Num: " + i + "(" + c.arrow[i] + ")\n");
      return(i);
        }
  }
  return(-1);
 }

   /*
Parameters:
	sub:    an array of integers which is the subpath we are looking for
	target: an array of integers which is being searched for sub
	start:  The place in target where the search is to begin
Purpose:
	To search one path, begining at some starting position, to see if another
	path is a subpath
Design:
	Returns the position where the subpath begins in the path being searched,
	 and -1 if sub is not a subpath of target
*/

  int search(int sub[], int target[], int start)
  {
    int i,j;
    boolean found;

	  found = false;
	  for (i=start;i<path_len(target);i++)
    {
		  if (sub[0] == target[i])
			{
			  found = true;
			  for (j=0;j<path_len(sub);j++)
				{
				  if (target[i+j] != sub[j])
					{
					  found = false;
					}
				}
			}
			if (found)
			{
				break;
			}
		}
	  if (found)
		{
  		return(i);
		}
  	else
		{
  		return(-1);
		}
  }



}