/*
Research Project:   Category Theory Database Tools
                    J. Bradbury, Dr. R. Rosebrugh
                    Mount Allison University 1999
File:               GDCT.java
Description:	      This file creates the application GDCT and displayes the
                    intro graphic frame (GDCTIntro.java) and displayes the main
                    frame (MainWindow.java).
*/

//import statements
import java.awt.*;

public class GDCT
{
  //Main method
  public static void main(String[] args)
  {
    //Create intro graphic frame
    GDCTIntro a = new GDCTIntro();
    Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
    Dimension frameSize = a.getSize();
    if (frameSize.height > screenSize.height)
      frameSize.height = screenSize.height;
    if (frameSize.width > screenSize.width)
      frameSize.width = screenSize.width;
    a.setLocation((screenSize.width - frameSize.width) / 2, (screenSize.height - frameSize.height) / 2);
    a.setSize(320,290);
    a.setResizable(false);
    a.setVisible(true);

    //Create main frame
    MainWindow  mw = new MainWindow(a);
    screenSize = Toolkit.getDefaultToolkit().getScreenSize();
    frameSize = mw.getSize();
    if (frameSize.height > screenSize.height)
      frameSize.height = screenSize.height;
    if (frameSize.width > screenSize.width)
      frameSize.width = screenSize.width;
    mw.setLocation((screenSize.width - frameSize.width) / 2, (screenSize.height - frameSize.height) / 2);
    mw.setVisible(true);
  }
}