 /*
Research Project:   Category Theory Database Tools
                    J. Bradbury, Dr. R. Rosebrugh
                    Mount Allison University 2000
File:               LoadFUNFrame.java
Description:        This class creates a frame that allows the user to select
                    the desired functor [FUN] to load from the server.
*/

//import statements
import java.applet.Applet;
import java.net.*;
import java.io.*;
import java.util.*;
import java.lang.System;
import java.io.StringBufferInputStream;
import java.awt.*;
import borland.jbcl.layout.*;
import java.awt.event.*;
import borland.jbcl.control.*;

public class LoadFUNFrame extends Frame {

  public String filename = new String();
  int check_enter = 0;
  Button exit = new Button();
  Panel button_panel = new Panel();
  BorderLayout borderLayout1 = new BorderLayout();
  XYLayout xYLayout1 = new XYLayout();
  Button okButton = new Button();
  List catLoadList = new List();
  Button cancelButton = new Button();
  GroupBox informationBox = new GroupBox();
  Label label1 = new Label();
  Label label2 = new Label();
  XYLayout xYLayout2 = new XYLayout();
  Label label3 = new Label();
  Label label4 = new Label();

  //global variables for reading file from server
  URL fileURL;
  InputStream input;
  DataInputStream dataInput;
  MainWindow edit = new MainWindow();

  public LoadFUNFrame(MainWindow ed, Button temp1, List temp2)
  {
    edit = ed;
    okButton = temp1;
    catLoadList = temp2;
    try  {
      jbInit();
    }
    catch (Exception e) {
      e.printStackTrace();
    }

  }

 public boolean handleEvent(Event e)
 {
  if ((e.id == Event.WINDOW_DESTROY) || (e.id == Event.ACTION_EVENT))
  {
     hide();            //hide frame
     dispose();         //free resources
     return true;
  }
  if (e.key == Event.ENTER)
  {
    if (check_enter == 0)
       check_enter++;
    else
    {
       hide();            //hide frame
       dispose();         //free resources
    }
    return true;
  }
  return super.handleEvent(e);
 }

 public boolean action(Event e, Object o)
 {
  if ((e.target == exit) || (e.key == Event.ENTER))
  {
   hide();            //hide frame
   dispose();         //free resources
   return true;
  }

  return false;
 }

  private void jbInit() throws Exception {
    this.setTitle("GDCT: Load File from " + edit.cons.server);
    this.setBackground(new Color(192,192,192));
    xYLayout1.setHeight(239);
    xYLayout1.setWidth(341);
    //okButton.setLabel("OK");
    //okButton.addActionListener(new java.awt.event.ActionListener() {
    //  public void actionPerformed(ActionEvent e) {
    //    catLoadList_okButton_actionPerformed(e);
    //  }
    //});
    cancelButton.setLabel("cancel");
    informationBox.setLayout(xYLayout2);
    informationBox.setLabel("NOTE");
    label1.setText("Files can only be loaded");
    label2.setText("from the server when");
    label3.setText("when connected to the");
    label4.setText("Internet.");
    //catLoadList.addActionListener(new java.awt.event.ActionListener() {
     // public void actionPerformed(ActionEvent e) {
    //    catLoadList_okButton_actionPerformed(e);
    //  }
    //});
    this.setLayout(xYLayout1);
    this.add(okButton, new XYConstraints(164, 131, 152, 31));
    this.add(catLoadList, new XYConstraints(13, 3, 138, 203));
    this.add(cancelButton, new XYConstraints(163, 170, 153, 31));
    this.add(informationBox, new XYConstraints(160, 4, 160, 122));
    informationBox.add(label1, new XYConstraints(-2, 8, 136, -1));
    informationBox.add(label2, new XYConstraints(-2, 29, -1, -1));
    informationBox.add(label3, new XYConstraints(-4, 51, -1, -1));
    informationBox.add(label4, new XYConstraints(-3, 74, 97, 22));
    boolean test = CreateCatList();

  }

  void catLoadList_okButton_actionPerformed(ActionEvent e)
  {
      filename = catLoadList.getSelectedItem();

  }

  public boolean CreateCatList()
  {
      try
      {
        fileURL = new URL(edit.cons.server + edit.cons.fundir);
      }
      catch (MalformedURLException except)
      {
        //String e1 = "Error\nUnable to open file\nFile unable to Load";
        //error_message(e1);
        //showStatus("Exception: " + except.toString());
      }
      boolean connected = ReadDirectory();
      if (catLoadList.countItems() == 0)
      {
        if (connected == false)
          new MessageDialog(this, "Error", edit.cons.server + edit.cons.fundir + "contains no valid category files", true);

        //String e1 = "Error\nCannot find Category Files to Load\nNo Category Files on Server\n";
        //error_message(e1);
        //catLoadList.clear();
      }
      return (connected);

  }

   public boolean ReadDirectory()
 //This method loads a category file from a server
 //This allows the applet to access files on the home
 //server as well as files on any other server
 {
  String text;
  StringTokenizer tokens;
  int linecount = 0;
  String temp;

  try
  {
      input = fileURL.openStream();
      dataInput = new DataInputStream(input);
      //viewbox.appendText("File Loaded\n\n");
      //viewbox.appendText("The File Contents are:\n\n");
      while((text=dataInput.readLine()) != null)
      {
            tokens = new StringTokenizer(text);
            while(tokens.hasMoreTokens())
            {
                temp = tokens.nextToken();
                if ((temp.charAt(0) == 'H') && (temp.charAt(1) == 'R'))
                {
                  int i = 6;
                  int j = 0;
                  char catname[] = new char[50];
                  String cname = new String();
                  while ( temp.charAt(i) != '"')
                  {
                      catname[j] = temp.charAt(i);
                      i++;
                      j++;
                  }
                    cname = temp.substring(6, i);
                  if (!cname.equals("/research.rosebrugh/gdct/fun"))
                  {
                    catLoadList.addItem(cname);
                  }
                }
            }
      }
      dataInput.close();
  }
  catch(IOException e)
  {
      new MessageDialog(this, "Error", "Unable to connect to " + edit.cons.server + edit.cons.fundir, true);
      return(false);
  }
  return(true);
 }

}

