 /*
Research Project:   Category Theory Database Tools
                    J. Bradbury, Dr. R. Rosebrugh
                    Mount Allison University 1999
File:               RecentFiles.java
Description:        This class reads and writes the list of the recent files to
                    and from a file
*/

//import statements
import java.io.*;

public class RecentFiles
{

  //File to access
  RandomAccessFile input;
  int rlen = 8;
  //rlen most recent files
  String recent[] = new String [rlen];
  String fname = new String();

  public RecentFiles(String filename)
  {
    fname = filename;
    try
    {
      input = new RandomAccessFile(filename, "rw");
    }
    catch(IOException e)
    {
      //Error Message Here
    }
  }

  public void readRecent()
  //Reads in all the records in the file input
  //and stores them in a linked list
  {
    boolean moreData = true;
    while (moreData == true)
    {
      try {
        read(input);
        //list.insertNode(rtemp);
        //rtemp = new record();
      }
      catch (IOException e) {
        moreData = false;
      }
    }
  }

  public void cleanup()
  //Closes the file when finished
  {
    try {
        input.close();
    }

    catch (IOException e) {
      System.err.println("ERROR during reading of file");
    }
  }

  public void saveRecent()
  //Saves all the records in the linked list to the file input
  {

    try {
          input.seek(0);  //Move to start of file
          write(input);   //Write new data
    }
    catch (IOException e)
    {
    }
  }

  public void read(RandomAccessFile file) throws IOException
  //This method reads data from a file
  {
    for (int i=0; i < rlen; i++)
      recent[i] = file.readUTF();
  }

  public void write(RandomAccessFile file) throws IOException
  //This method writes data to a file
  {
    for (int i = 0; i < rlen; i++)
    {
      file.writeUTF(recent[i]);
    }
  }

}
