/*
Research Project:   Category Theory Database Tools
                    J. Bradbury, Dr. R. Rosebrugh
                    Mount Allison University 1999
File:               RemoveCatFrame.java
Description:	      This file is displayed when the user selects the "Remove
                    Category" menu option in the main window. It displays a
                    list of categories that are presently in memory. The user
                    can select a category file(*.CAT) and chose to remove it.
*/

//import statements
import java.applet.Applet;
import java.net.*;
import java.io.*;
import java.util.*;
import java.lang.System;
import java.io.StringBufferInputStream;
import java.awt.*;
import borland.jbcl.layout.*;
import java.awt.event.*;
import borland.jbcl.control.*;

public class RemoveCatFrame extends Frame {

  public String filename = new String();
  int check_enter = 0;
  Button exit = new Button();
  Panel button_panel = new Panel();
  BorderLayout borderLayout1 = new BorderLayout();
  XYLayout xYLayout1 = new XYLayout();
  Button okButton = new Button();
  List catRemoveList = new List();
  Button cancelButton = new Button();
  DefList l = new DefList();
  MainWindow edit = new MainWindow();

  public RemoveCatFrame(DefList ltemp, MainWindow ed)
  {
    l = ltemp;
    edit = ed;
    try  {
      jbInit();
    }
    catch (Exception e) {
      e.printStackTrace();
    }
  }

 public boolean handleEvent(Event e)
 {
  if ((e.id == Event.WINDOW_DESTROY) || (e.id == Event.ACTION_EVENT))
  {
     hide();            //hide frame
     dispose();         //free resources
     return true;
  }
  else if (e.key == Event.ENTER)
  {
    if (check_enter == 0)
       check_enter++;
    else
    {
       hide();            //hide frame
       dispose();         //free resources
    }
    return true;
  }
  return super.handleEvent(e);
 }

 public boolean action(Event e, Object o)
 {
  if ((e.target == exit) || (e.key == Event.ENTER))
  {
   hide();            //hide frame
   dispose();         //free resources
   return true;
  }
  return false;
 }

  private void jbInit() throws Exception {
    this.setTitle("GDCT: Remove Category");
    this.setBackground(new Color(192,192,192));
    xYLayout1.setHeight(163);
    okButton.setLabel("OK");
    xYLayout1.setWidth(305);
    okButton.setLabel("OK");
    okButton.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        catRemoveList_okButton_actionPerformed(e);
      }
    });
    cancelButton.setLabel("cancel");

    catRemoveList.setBackground(Color.white);
    catRemoveList.addActionListener(new java.awt.event.ActionListener() {
     public void actionPerformed(ActionEvent e) {
        catRemoveList_okButton_actionPerformed(e);
      }
    });
    this.setLayout(xYLayout1);
    this.add(okButton, new XYConstraints(152, 24, 128, 31));
    this.add(catRemoveList, new XYConstraints(13, 9, 126, 111));
    this.add(cancelButton, new XYConstraints(152, 67, 128, 31));
    catRemoveList.clear();
    ListNode current = l.head;
    while(current != null)
    {
      catRemoveList.addItem(current.cat.name);
      current = current.next;
    }
  }

  void catRemoveList_okButton_actionPerformed(ActionEvent e)
  {
      String name;
      boolean test;
      if (catRemoveList.getSelectedItem() != null)
      {
        name = catRemoveList.getSelectedItem();
        if (!name.equals(""))
        {
          test = l.removeNode(name);
          boolean current = false;
          if (name.equals(edit.categoryChoice.getSelectedItem()))
          {
            edit.objectArea.setText("");
            edit.arrowArea.setText("");
            edit.relationArea.setText("");
            edit.commentArea.setText("");
            boolean graph = edit.displayCategory("graph [directed 1]");
            current = true;
          }
          edit.categoryChoice.remove(name);
          if (current == true && edit.categoryChoice.countItems() != 0)
          {
            edit.cat = l.getNode(edit.categoryChoice.getSelectedItem());
            if (!edit.cat.filename.equals(""))
            {
              edit.setTitle("Graphical Database for Category Theory [" + edit.cat.filename + "]");
              edit.validate();
            }
            else
            {
              edit.setTitle("Graphical Database for Category Theory [ GDCT 1999 ]");
              edit.validate();
            }
            edit.displayCategory(edit.cat);
            if (edit.cat.gml.equals(""))
              edit.GraphCategory(edit.graph_, edit.graphCanvas_, edit.cat);
            else
            {
              boolean display = edit.displayCategory(edit.cat.gml);
            }
          }
          if (test == false)
          {
            new MessageDialog(this, "Error", "Unable to Remove Category", true);
          }
        }
        else
        {
          new MessageDialog(this, "Error", "Invalid Category Name", true);
        }
        catRemoveList.clear();
        hide();
        dispose();
      }
      else
      {
          new MessageDialog(this, "Error", "No category file selected", true);
      }
  }
}
