/*
Research Project:   Category Theory Database Tools
                    J. Bradbury, Dr. R. Rosebrugh
                    Mount Allison University 1999
File:               RemoveDataFrame.java
Description:	      This file is displayed when the user selects the "Remove
                    Data" menu option in the "Edit Category" menu of the  main
                    window. It allows the user to remove objects, arrows, and
                    relations from the current category.
*/

//import statements
import java.awt.*;
import borland.jbcl.layout.*;
import java.awt.event.*;
import borland.jbcl.control.*;

public class RemoveDataFrame extends Frame {

  Category c = new Category();
  DefList l = new DefList();
  int check_enter = 0;

  //Objects in the Graphical User Interface(GUI)
  Button exit = new Button();
  Panel button_panel = new Panel();
  BorderLayout borderLayout1 = new BorderLayout();
  Button okButton = new Button();
  List relRemoveList = new List();
  Button cancelButton = new Button();
  Label label1 = new Label();
  Label label2 = new Label();
  TextField categoryField = new TextField();
  MainWindow edit = new MainWindow();
  Label label3 = new Label();
  Label label4 = new Label();
  List objRemoveList = new List();
  List arrRemoveList = new List();
  TextArea statusArea = new TextArea("", 10, 10, TextArea.SCROLLBARS_VERTICAL_ONLY);
  GroupBox groupBox1 = new GroupBox();
  Label label5 = new Label();
  GridBagLayout gridBagLayout1 = new GridBagLayout();
  GridBagLayout gridBagLayout2 = new GridBagLayout();

  public RemoveDataFrame(MainWindow ed)
  //Default Constructor with the list of categories as a parameter
  {
    edit = ed;
    try  {
      jbInit();
    }
    catch (Exception e) {
      e.printStackTrace();
    }
  }

  public boolean handleEvent(Event e)
  {
    if ((e.id == Event.WINDOW_DESTROY) || (e.id == Event.ACTION_EVENT))
    {
     hide();            //hide frame
     dispose();         //free resources
     return true;
    }
    else if (e.key == Event.ENTER)
    {
      if (check_enter == 0)
       check_enter++;
      else
      {
       hide();            //hide frame
       dispose();         //free resources
      }
      return true;
    }
    return super.handleEvent(e);
  }

 public boolean action(Event e, Object o)
 {
  if ((e.target == exit) || (e.key == Event.ENTER))
  {
   hide();            //hide frame
   dispose();         //free resources
   return true;
  }
  return false;
 }


 private void jbInit() throws Exception
 //This function intializes the GUI
 {
    this.setTitle("GDCT: Remove Data from Category");
    this.setBackground(new Color(192,192,192));
    okButton.setLabel("OK");
    okButton.setLabel("Remove");
    okButton.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        relRemoveList_okButton_actionPerformed(e);
      }
    });
    cancelButton.setLabel("Close");
    label1.setText("Relation(s) to Remove:");
    label2.setText("Current Category:");
    relRemoveList.setBackground(Color.white);
    relRemoveList.addActionListener(new java.awt.event.ActionListener() {
     public void actionPerformed(ActionEvent e) {
        relRemoveList_okButton_actionPerformed(e);
      }
    });
    this.setLayout(gridBagLayout1);
    categoryField.setBackground(Color.white);
    groupBox1.setLayout(gridBagLayout2);
    this.add(okButton, new GridBagConstraints2(2, 3, 2, 1, 0.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(17, 13, 0, 0), 82, 8));
    this.add(cancelButton, new GridBagConstraints2(2, 4, 2, 1, 0.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(18, 15, 12, 0), 93, 8));
    this.add(label2, new GridBagConstraints2(2, 1, 1, 1, 0.0, 0.0
            ,GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(0, 12, 0, 0), 0, 0));
    this.add(categoryField, new GridBagConstraints2(2, 2, 2, 1, 1.0, 0.0
            ,GridBagConstraints.WEST, GridBagConstraints.HORIZONTAL, new Insets(0, 12, 0, 0), 119, 2));
    this.add(statusArea, new GridBagConstraints2(0, 2, 2, 3, 1.0, 1.0
            ,GridBagConstraints.CENTER, GridBagConstraints.BOTH, new Insets(0, 12, 13, 0), 172, -48));
    this.add(groupBox1, new GridBagConstraints2(0, 0, 5, 1, 1.0, 1.0
            ,GridBagConstraints.CENTER, GridBagConstraints.BOTH, new Insets(9, 6, 0, 8), -2, -2));
    groupBox1.add(label4, new GridBagConstraints2(0, 0, 1, 1, 0.0, 0.0
            ,GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(1, 7, 0, 0), -11, -3));
    groupBox1.add(label3, new GridBagConstraints2(2, 0, 1, 1, 0.0, 0.0
            ,GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(1, 20, 0, 0), -8, 1));
    groupBox1.add(label1, new GridBagConstraints2(3, 0, 2, 1, 0.0, 0.0
            ,GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(1, 16, 0, -2), -10, -4));
    groupBox1.add(arrRemoveList, new GridBagConstraints2(2, 1, 1, 1, 1.0, 1.0
            ,GridBagConstraints.CENTER, GridBagConstraints.BOTH, new Insets(0, 18, 0, 0), -8, 71));
    groupBox1.add(relRemoveList, new GridBagConstraints2(3, 1, 1, 1, 1.0, 1.0
            ,GridBagConstraints.CENTER, GridBagConstraints.BOTH, new Insets(0, 20, -1, 0), -4, 72));
    groupBox1.add(objRemoveList, new GridBagConstraints2(0, 1, 1, 1, 1.0, 1.0
            ,GridBagConstraints.CENTER, GridBagConstraints.BOTH, new Insets(0, 7, 0, 0), -11, 71));
    this.add(label5, new GridBagConstraints2(0, 1, 1, 1, 0.0, 0.0
            ,GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(0, 14, 0, 0), -8, 3));
    relRemoveList.clear();

    //Allow for the selection of multiple arrows, objects, relations
    objRemoveList.setMultipleSelections(true);
    arrRemoveList.setMultipleSelections(true);
    relRemoveList.setMultipleSelections(true);

    c = edit.cat;
    cancelButton.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        cancelButton_actionPerformed(e);
      }
    });
    label5.setText("Remove Status:");
    groupBox1.setLabel("Remove Lists");
    label4.setText("Object(s) to Remove:");
    label3.setText("Arrow(s) to Remove:");
    categoryField.setEditable(false);
    categoryField.setText(c.name);

    //Add objects to remove objects list
    for (int i = 0; i < c.numobj; i++)
      objRemoveList.addItem("" + c.obj[i]);
    //if (objRemoveList.countItems() == 0)
    //{
    //  new MessageDialog(this, "Error", "Can not remove object, category has 0 objects", true);
    //}


    //Add arrows to remove arrows list
    for (int i = 0; i < c.numarr; i++)
    {
      arrRemoveList.addItem(c.arrow[i] + ":" + c.obj[c.arr[i][0]] + "->" + c.obj[c.arr[i][1]]);
    }
    //if (arrRemoveList.countItems() == 0)
    //{
    //      new MessageDialog(this, "Error", "Can not remove arrow, category has 0 arrows", true);
    //}


    //Add relations to remove relations list
    String rel = new String();
    int j=0;
    for (int i = 0; i < c.num_rel; i++)
    {
      rel = new String();
      j = 0;
      //Display left side of relation
      while (c.rel_set[i].lhs[j] != -1)
      {
        if (j == 0)
          rel = rel.concat("" + c.arrow[c.rel_set[i].lhs[j]]);
        else
          rel = rel.concat("*" + c.arrow[c.rel_set[i].lhs[j]]);
        j++;
      }
      rel = rel.concat(" = ");
      j = 0;
      //Display right side of relation
      if (c.rel_set[i].rhs[0] == edit.cons.id_code)
        rel = rel.concat("1");
      else
      {
        while (c.rel_set[i].rhs[j] != -1)
        {
          if (j == 0)
            rel = rel.concat("" + c.arrow[c.rel_set[i].rhs[j]]);
          else
            rel = rel.concat("*" + c.arrow[c.rel_set[i].rhs[j]]);
          j++;
        }
      }
      relRemoveList.addItem(rel);
    }
  }


  void relRemoveList_okButton_actionPerformed(ActionEvent e)
  //Function called when OK button is pressed or when an item
  //in the objRemoveList is double clicked
  {
      //String temp;
      //boolean test;
      //char tmp;
      //int check=0;


    if (relRemoveList.getSelectedItems() != null)
    {
      String remove_rels[] = relRemoveList.getSelectedItems();
      for (int i = 0; i < relRemoveList.getItemCount(); i++)
      {
        try
        {
          String temp = remove_rels[i];
          int nummenu = 0;
          for (int j = 0; j < relRemoveList.getItemCount(); j++)
          {
            if (temp.equals(relRemoveList.getItem(j)))
              nummenu = j;
          }
          nummenu++;
          int relnum = ask_for_rel(nummenu, c);
          if (relnum != -1)
          {
            remove_rel(relnum);
            relRemoveList.remove(temp);
            statusArea.append("Relation " + temp + " removed.\n\n");
          }
          //categoryField.setText(categoryField.getText() + "  " + relnum + "  " + temp);
        }
        catch (ArrayIndexOutOfBoundsException aie)
        {
        }
      }
    }
    else
    {
      new MessageDialog(this, "Error","Relation must be selected before it can be removed", true);
    }
    removeArrows();
    removeObjects();
    //end();
    statusArea.setCaretPosition(0);
    //hide();
    //dispose();

 }

  public void removeArrows()
  {
    int nummenu = 0;
    String temp;
    boolean test;
    char tmp;
    int check=0;

    if (arrRemoveList.getSelectedItems() != null)
    {
      String remove_arrs[] = arrRemoveList.getSelectedItems();
      for (int i = 0; i < arrRemoveList.getItemCount(); i++)
      {
        try
        {
          temp = remove_arrs[i];
          for (int j = 0; j < arrRemoveList.getItemCount(); j++)
          {
            if (temp.equals(arrRemoveList.getItem(j)))
              nummenu = j+1;
          }
          int arrnum = ask_for_arr(nummenu);
          if (arrnum != -1)
          {
            statusArea.append("Arrow " + temp + " removed.\n\n");
            remove_arr(arrnum);
            arrRemoveList.remove(temp);
            l.replaceNode(c);
          }
        }
        catch (ArrayIndexOutOfBoundsException aie)
        {
        }
      }
      //end();
    }
    else
    {
          new MessageDialog(this, "Error", "Arrow must be selected before it can be removed", true);
    }
  }

  public void removeObjects()
  {
    String temp;
    boolean test;
    char tmp;
    int check=0;
    int obj = -1;
    boolean depend_arrows = false;

    if (objRemoveList.getSelectedItems() != null)
    {
      String remove_objs[] = objRemoveList.getSelectedItems();
      for (int i = 0; i < objRemoveList.getItemCount(); i++)
      {
        try
        {
          temp = remove_objs[i];
          for(int j=0; j < c.numobj; j++)
          {
            if (c.obj[j].equals(temp))
            obj = j;
          }

          String depend_arrs = new String();
          for(int j=0; j < c.numarr; j++)
          {
            if (c.arr[i][0] == obj || c.arr[i][1] == obj)
            {
              if (depend_arrows == false)
                depend_arrs = c.arrow[j];
              else
                depend_arrs = depend_arrs.concat(", " + c.arrow[j]);
              depend_arrows = true;
              //new MessageDialog(this, "Error", c.arrow[j] + " dependent on object " + c.obj[obj] + " remove arrow first", true);
            }
          }
          if (depend_arrows == false)
          {
            for(int j = obj; j < c.numobj; j++)
            {
              c.obj[j]= c.obj[j+1];
            }
            c.numobj--;
            statusArea.append("Object " + temp + " removed.\n\n");
            objRemoveList.remove(temp);
            //end();
          }
          else
          {
            statusArea.append("Object " + temp + " NOT removed. Arrows " + depend_arrs + " dependent on object " + temp + ".\n\n");
            depend_arrows = false;
          }
        }
        catch (ArrayIndexOutOfBoundsException aie)
        {
        }
      }
    }
    else
    {
          new MessageDialog(this, "Error", "Object must be selected beore it can be removed", true);
    }
  }


  public int ask_for_rel(int n, Category c)
  //Returns relation index number or -1 if relation not found
  {
    if ((n <= c.num_rel) && (n > 0))
    {
      return(n-1);
    }
    return(-1);
  }

  public void remove_rel(int rel)
  //Removes the relation from the category and uses the following parameters:
  //       rel:    the relation to be removed from the category
  //       A  :    the category which contains the relation
  {
    int i;

    for (i=rel; i<c.num_rel- 1;i++)
    {
      c.rel_set[i] = c.rel_set[i+1];
    }
    c.num_rel--;
  }

    public int ask_for_arr(int n)
  // This function takes in as a parameter the menu number of the arrow and
  // checks to see if the arrow the user asked for has dependent relations
  //and it returns the number of the arrow in the category dependent on it,
  //otherwise gives an error message and returns -1.
  {
    if ((n <= c.numarr) && (n > 0))
    {
        //viewbox.appendText(Integer.toString(n));
        if (c.num_rel == 0)
          return(n-1);
        else if (!arrow_in_rel(n-1))
        {
          return(n-1);
        }
        else
        {
          statusArea.append("Arrow " + c.arrow[n-1] + " NOT removed. Arrow has relations dependent on it.\n\n");
          //new MessageDialog(this, "Error", "Unable to remove arrow, arrow has relations dependent on it", true);
          return(-1);
        }
    }
    return(-1); //n is not an arrow in category
  }

  public void remove_arr(int arr)
  //This function removes the specified arrow from the category. It accepts as
  //parameters:
  //      arr:    the arrow to be removed from the category
  //      A  :    the category which contains the arrow
  {
    int i,j;

    for (i=arr;i<  c.numarr - 1;i++)
    {
      c.arrow[i] = c.arrow[i+1];
      c.arr[i][0] = c.arr[i+1][0];
      c.arr[i][1] = c.arr[i+1][1];
    }
    c.numarr--;
    for (i=0;i<c.num_rel;i++)
    {
      for (j=0;j<path_len(c.rel_set[i].lhs);j++)
      {
        if (c.rel_set[i].lhs[j] > arr)
        {
          (c.rel_set[i].lhs[j])--;
        }
      }
      for (j=0;j<path_len(c.rel_set[i].rhs);j++)
      {
        if (c.rel_set[i].rhs[j] > arr)
        {
          (c.rel_set[i].rhs[j])--;
        }
      }
    }
  }

    public int path_len(int path[])
  /*
  Parameters:
        path:   an array of integers terminated by -1 which is a path
  Purpose:
        To determine the length of an array of integers terminated by -1
  Design:
        Returns the number of integers in the path, does not count -1
  */
  {
    int length = 0;

    if ((path[0] == edit.cons.id_code) && (path[1] == -1))
      return(0);

    while (path[length] != -1)
    {
      length++;
    }
    return(length);
  }


   public boolean arrow_in_rel(int arr)
  /*
  Parameters:
        arr:    the arrow being searched for in the set of relations
        A:              the category which contains the set of relations being searched
  Purpose:
        To search the set of relations to see if the given arrow occurs in any of
        the relations
  Design:
        Returns true if the arrow does occur in at least one relation, and false
        if it does not occur in any of the relations.
  */
  {
    int i,j;

    for (i=0;i<c.num_rel;i++)
    {
      for (j=0;j<path_len(c.rel_set[i].lhs);j++)
      {
        if (c.rel_set[i].lhs[j] == arr)
        {
          return(true);
        }
      }
      for (j=0;j<path_len(c.rel_set[i].rhs);j++)
      {
        if (c.rel_set[i].rhs[j] == arr)
        {
          return(true);
        }
      }
    }
    return(false);
  }

  void cancelButton_actionPerformed(ActionEvent e)
  {
    if ((c.num_rel < edit.cat.num_rel) || (c.numarr < edit.cat.numarr) || (c.numobj < edit.cat.numobj))
    {
      edit.List.replaceNode(c);
      edit.cat = c;
      //Clear graphical display HERE
      edit.displayCategory(edit.cat);
      edit.GraphCategory(edit.graph_, edit.graphCanvas_, edit.cat);
    }
    hide();
    dispose();
  }



}