/*
Research Project:   Category Theory Database Tools
                    J. Bradbury, Dr. R. Rosebrugh
                    Mount Allison University 1999
File:               RemoveFunctorFrame.java
Description:	      This file is displayed when the user selects the "Remove
                    Category" menu option in the main window. It displays a
                    list of categories that are presently in memory. The user
                    can select a category file(*.CAT) and chose to remove it.
*/

//import statements
import java.applet.Applet;
import java.net.*;
import java.io.*;
import java.util.*;
import java.lang.System;
import java.io.StringBufferInputStream;
import java.awt.*;
import borland.jbcl.layout.*;
import java.awt.event.*;
import borland.jbcl.control.*;

public class RemoveFunctorFrame extends Frame {

  public String filename = new String();
  int check_enter = 0;
  Button exit = new Button();
  Panel button_panel = new Panel();
  BorderLayout borderLayout1 = new BorderLayout();
  XYLayout xYLayout1 = new XYLayout();
  Button okButton = new Button();
  List funcRemoveList = new List();
  Button cancelButton = new Button();
  MainWindow edit = new MainWindow();

  public RemoveFunctorFrame(MainWindow ed)
  {
    edit = ed;
    try  {
      jbInit();
    }
    catch (Exception e) {
      e.printStackTrace();
    }
  }

 public boolean handleEvent(Event e)
 {
  if ((e.id == Event.WINDOW_DESTROY) || (e.id == Event.ACTION_EVENT))
  {
     hide();            //hide frame
     dispose();         //free resources
     return true;
  }
  else if (e.key == Event.ENTER)
  {
    if (check_enter == 0)
       check_enter++;
    else
    {
       hide();            //hide frame
       dispose();         //free resources
    }
    return true;
  }
  return super.handleEvent(e);
 }

 public boolean action(Event e, Object o)
 {
  if ((e.target == exit) || (e.key == Event.ENTER))
  {
   hide();            //hide frame
   dispose();         //free resources
   return true;
  }
  return false;
 }

  private void jbInit() throws Exception {
    this.setTitle("GDCT: Remove Functor");
    this.setBackground(new Color(192,192,192));
    xYLayout1.setHeight(163);
    okButton.setLabel("OK");
    xYLayout1.setWidth(305);
    okButton.setLabel("OK");
    okButton.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        funcRemoveList_okButton_actionPerformed(e);
      }
    });
    cancelButton.setLabel("cancel");

    funcRemoveList.setBackground(Color.white);
    funcRemoveList.addActionListener(new java.awt.event.ActionListener() {
     public void actionPerformed(ActionEvent e) {
        funcRemoveList_okButton_actionPerformed(e);
      }
    });
    this.setLayout(xYLayout1);
    this.add(okButton, new XYConstraints(152, 24, 128, 31));
    this.add(funcRemoveList, new XYConstraints(13, 9, 126, 111));
    this.add(cancelButton, new XYConstraints(152, 67, 128, 31));
    funcRemoveList.clear();
    functor_node current = edit.f_list.head;
    while(current != null)
    {
      funcRemoveList.addItem(current.f.name);
      current = current.next;
    }
  }

  void funcRemoveList_okButton_actionPerformed(ActionEvent e)
  {
      String name;
      boolean test;
      if (funcRemoveList.getSelectedItem() != null)
      {
        name = funcRemoveList.getSelectedItem();
        if (!name.equals(""))
        {
          test = edit.f_list.removeNode(name);
          boolean current = false;
          if (name.equals(edit.functorChoice.getSelectedItem()))
          {
            edit.functorObjectArea.setText("");
            edit.functorArrowArea.setText("");
            //boolean graph = edit.displayFunctor("graph [directed 1]");
            current = true;
          }
          edit.functorChoice.remove(name);
          /*if (current == true && edit.functorChoice.countItems() != 0)
          {
            edit.f = l.getNode(edit.functorChoice.getSelectedItem());
            if (!edit.cat.filename.equals(""))
            {
              edit.setTitle("Category Theory Database Tools [" + edit.cat.filename + "]");
              edit.validate();
            }
            else
            {
              edit.setTitle("Category Theory Database Tools [ CTDT 1999 ]");
              edit.validate();
            }
            edit.displayCategory(edit.cat);
            if (edit.cat.gml.equals(""))
              edit.GraphCategory(edit.graph_, edit.graphCanvas_, edit.cat);
            else
            {
              boolean display = edit.displayCategory(edit.cat.gml);
            }
          } */
          if (test == false)
          {
            new MessageDialog(this, "Error", "Unable to remove category", true);
          }
        }
        else
        {
          new MessageDialog(this, "Error", "Invalid category name", true);
        }
        funcRemoveList.clear();
        hide();
        dispose();
      }
      else
      {
        new MessageDialog(this, "Error", "No category file selected", true);
      }
  }
}
