 /*
Research Project:   Category Theory Database Tools
                    J. Bradbury, Dr. R. Rosebrugh
                    Mount Allison University 1999
File:               SettingsAnimation.java
Description:        This class creates a frame that allows the user to change
                    the speed of the auto animate functor as well as allows the
                    user to select the desired color for the highlighted objects
                    and arrows in both category A and category B.
*/

//import statements
import java.awt.*;
import borland.jbcl.layout.*;
import java.awt.event.*;
import borland.jbcl.control.*;

public class SettingsAnimation extends Frame {

  Category c = new Category();
  DefList l = new DefList();
  int check_enter = 0;

  //Objects in the Graphical User Interface(GUI)
  Button exit = new Button();
  XYLayout xYLayout1 = new XYLayout();
  MainWindow ed = new MainWindow();
  GroupBox speedGroupBox = new GroupBox();
  XYLayout xYLayout2 = new XYLayout();
  Button okButton = new Button();
  GroupBox colorsGroupBox = new GroupBox();
  Label label1 = new Label();
  Label label2 = new Label();
  TextField animationText = new TextField();
  XYLayout xYLayout3 = new XYLayout();
  ColorChooser colorChooser1 = new ColorChooser();
  Label ALabel = new Label();
  Label BLabel = new Label();
  Choice AChoice = new Choice();
  Choice BChoice = new Choice();
  Button cancelButton = new Button();


  public SettingsAnimation(MainWindow edit)
  //Default Constructor with the parent frame as a parameter
  {
    ed = edit;
    try  {
      jbInit();
    }
    catch (Exception e) {
      e.printStackTrace();
    }
  }

  public boolean handleEvent(Event e)
  {
    if ((e.id == Event.WINDOW_DESTROY))//|| (e.id == Event.ACTION_EVENT))
    {
     hide();            //hide frame
     dispose();         //free resources
     return true;
    }
    /*else if (e.key == Event.ENTER)
    {
      if (check_enter == 0)
       check_enter++;
      else
      {
       hide();            //hide frame
       dispose();         //free resources
      }
      return true;
    } */
    return super.handleEvent(e);
  }

 public boolean action(Event e, Object o)
 {
  if ((e.target == exit) || (e.key == Event.ENTER))
  {
   hide();            //hide frame
   dispose();         //free resources
   return true;
  }
  return false;
 }


 private void jbInit() throws Exception
 //This function intializes the GUI
 {
    this.setTitle("GDCT: Functor Animation Settings");
    this.setBackground(new Color(192,192,192));
    xYLayout1.setHeight(181);
    speedGroupBox.setLayout(xYLayout2);
    speedGroupBox.setLabel("Animation Speed");
    label1.setText("Auto Animation Speed");
    label2.setText("seconds");
    ALabel.setText("Category A Color:");
    BLabel.setText("Cateogry B Color:");
    cancelButton.setLabel("Cancel");
    cancelButton.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        cancelButton_actionPerformed(e);
      }
    });
    Font f = ed.objectArea.getFont();

    okButton.setLabel("OK");
    colorsGroupBox.setLayout(xYLayout3);
    colorsGroupBox.setLabel("Animation Colors");
    okButton.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        okButton_actionPerformed(e);
      }
    });
    xYLayout1.setWidth(433);
    this.setLayout(xYLayout1);
    this.add(speedGroupBox, new XYConstraints(8, 17, 174, 100));
    speedGroupBox.add(label1, new XYConstraints(17, 11, 128, 27));
    speedGroupBox.add(label2, new XYConstraints(91, 44, 56, 30));
    speedGroupBox.add(animationText, new XYConstraints(19, 40, 67, 25));
    this.add(okButton, new XYConstraints(151, 117, 127, 30));
    this.add(colorsGroupBox, new XYConstraints(180, 17, 236, 99));
    colorsGroupBox.add(ALabel, new XYConstraints(1, 13, 100, -1));
    colorsGroupBox.add(BLabel, new XYConstraints(1, 45, 100, -1));
    colorsGroupBox.add(AChoice, new XYConstraints(107, 12, 101, 22));
    colorsGroupBox.add(BChoice, new XYConstraints(107, 44, 100, 21));
    this.add(cancelButton, new XYConstraints(287, 117, 124, 30));

    choiceInitial(AChoice, ed.cons.AColor);
    choiceInitial(BChoice, ed.cons.BColor);
    animationText.setText(ed.cons.animation_delay/1000 + "");
    animationText.selectAll();
 }

  void choiceInitial(Choice c, Color col)
  //Initialize choice menu
  {
    c.add("Red");
    c.add("Blue");
    c.add("Green");
    c.add("Yellow");
    if (col.equals(Color.red))
      c.select("Red");
    if (col.equals(Color.blue))
      c.select("Blue");
    if (col.equals(Color.green))
      c.select("Green");
    if (col.equals(Color.yellow))
      c.select("Yellow");
  }

  void okButton_actionPerformed(ActionEvent e)
  //This method is called when the "OK" button is pressed
  //It closes the text settings frame
  {
    try
    {
      if (AChoice.getSelectedItem().equals("Red"))
        ed.cons.AColor = Color.red;
      else if (AChoice.getSelectedItem().equals("Blue"))
        ed.cons.AColor = Color.blue;
      else if (AChoice.getSelectedItem().equals("Green"))
        ed.cons.AColor = Color.green;
      else if (AChoice.getSelectedItem().equals("Yellow"))
        ed.cons.AColor = Color.yellow;
      if (BChoice.getSelectedItem().equals("Red"))
        ed.cons.BColor = Color.red;
      else if (BChoice.getSelectedItem().equals("Blue"))
        ed.cons.BColor = Color.blue;
      else if (BChoice.getSelectedItem().equals("Green"))
        ed.cons.BColor = Color.green;
      else if (BChoice.getSelectedItem().equals("Yellow"))
        ed.cons.BColor = Color.yellow;
      ed.cons.animation_delay = Integer.parseInt(animationText.getText()) * 1000;
      hide();            //hide frame
      dispose();         //free resources
    }
    catch (NumberFormatException e1)
    {
      new MessageDialog(this, "Error", "Animation speed must be an integer", true);
    }
  }

  void cancelButton_actionPerformed(ActionEvent e)
  //This method is called when the "Cancel" button is pressed
  //It closes the text settings frame
  {
    hide();            //hide frame
    dispose();         //free resources
  }
}
