 /*
Research Project:   Category Theory Database Tools
                    J. Bradbury, Dr. R. Rosebrugh
                    Mount Allison University 1999
File:               SettingsFuncGraphical.java
Description:	      This file creates a frame that allows the user to change
                    the graphical setttings associated with the display of
                    categories A and B in the current functor.
*/

//import statements
import java.awt.*;
import borland.jbcl.layout.*;
import java.awt.event.*;
import borland.jbcl.control.*;

public class SettingsFuncGraphical extends Frame {

  Category c = new Category();
  DefList l = new DefList();
  int check_enter = 0;

  //Objects in the Graphical User Interface(GUI)
  Button exit = new Button();
  Panel button_panel = new Panel();
  BorderLayout borderLayout1 = new BorderLayout();
  XYLayout xYLayout1 = new XYLayout();
  Button okButton = new Button();
  Checkbox setFontB = new Checkbox();
  CheckboxGroup AScaleGroup = new CheckboxGroup();
  CheckboxGroup BScaleGroup = new CheckboxGroup();
  CheckboxGroup LayoutGroup = new CheckboxGroup();
  Checkbox scaleDecreaseB = new Checkbox("", BScaleGroup, false);
  Checkbox scaleIncreaseB = new Checkbox("", BScaleGroup, false);
  Checkbox scaleOneB = new Checkbox("", BScaleGroup, false);
  Checkbox centerOffsetB = new Checkbox();
  MainWindow ed = new MainWindow();
  GroupBox groupBox1 = new GroupBox();
  XYLayout xYLayout2 = new XYLayout();
  Panel panel1 = new Panel();
  Panel panel2 = new Panel();
  Panel panel3 = new Panel();
  Panel panel4 = new Panel();
  Panel panel5 = new Panel();
  Panel panel6 = new Panel();
  XYLayout xYLayout6 = new XYLayout();
  Label label1 = new Label();
  XYLayout xYLayout7 = new XYLayout();
  XYLayout xYLayout8 = new XYLayout();
  XYLayout xYLayout9 = new XYLayout();
  XYLayout xYLayout10 = new XYLayout();
  XYLayout xYLayout11 = new XYLayout();
  Label label2 = new Label();
  Label label3 = new Label();
  Label label4 = new Label();
  Label label5 = new Label();
  Label label6 = new Label();
  Checkbox vertLayout = new Checkbox("", LayoutGroup, false);
  Checkbox horizLayout = new Checkbox("", LayoutGroup, false);
  Checkbox aOnlyLayout = new Checkbox("", LayoutGroup, false);
  Checkbox bOnlyLayout = new Checkbox("", LayoutGroup, false);
  GroupBox groupBox2 = new GroupBox();
  XYLayout xYLayout12 = new XYLayout();
  Checkbox scaleDecreaseA = new Checkbox("", AScaleGroup, false);
  XYLayout xYLayout13 = new XYLayout();
  Checkbox scaleOneA = new Checkbox("", AScaleGroup, false);
  Checkbox scaleIncreaseA = new Checkbox("", AScaleGroup, false);
  Checkbox setFontA = new Checkbox();
  Checkbox centerOffsetA = new Checkbox();
  GroupBox groupBox3 = new GroupBox();



  public SettingsFuncGraphical(MainWindow edit)
  //Default Constructor with the parent frame as a parameter
  {
    ed = edit;
    try  {
      jbInit();
    }
    catch (Exception e) {
      e.printStackTrace();
    }
  }

  public boolean handleEvent(Event e)
  {
    if ((e.id == Event.WINDOW_DESTROY) || (e.id == Event.ACTION_EVENT))
    {
     hide();            //hide frame
     dispose();         //free resources
     return true;
    }
    else if (e.key == Event.ENTER)
    {
      if (check_enter == 0)
       check_enter++;
      else
      {
       hide();            //hide frame
       dispose();         //free resources
      }
      return true;
    }
    return super.handleEvent(e);
  }

 public boolean action(Event e, Object o)
 {
  if ((e.target == exit) || (e.key == Event.ENTER))
  {
   hide();            //hide frame
   dispose();         //free resources
   return true;
  }
  return false;
 }


 private void jbInit() throws Exception
 //This function intializes the GUI
 {
    //Set Frame Properties and Layout
    this.setTitle("GDCT: Graphical Functor Settings");
    this.setBackground(new Color(192,192,192));
    xYLayout1.setHeight(421);
    xYLayout1.setWidth(497);
    this.setLayout(xYLayout1);

    //GUI for Functor Display Settings
    okButton.setLabel("OK");
    groupBox1.setLayout(xYLayout2);
    groupBox1.setLabel("Category Display Layout");
    panel1.setBackground(Color.white);
    panel1.setLayout(xYLayout6);
    panel2.setBackground(Color.white);
    panel2.setLayout(xYLayout11);
    panel3.setBackground(Color.white);
    panel3.setLayout(xYLayout9);
    panel4.setBackground(Color.white);
    panel4.setLayout(xYLayout10);
    panel5.setBackground(Color.white);
    panel5.setLayout(xYLayout7);
    panel6.setBackground(Color.white);
    panel6.setLayout(xYLayout8);
    label1.setFont(new Font("Dialog", 1, 12));
    label1.setText("A");
    label2.setText("B");
    label3.setText("A");
    label4.setText("A");
    label5.setFont(new Font("Dialog", 1, 12));
    label5.setText("B");
    label6.setFont(new Font("Dialog", 1, 12));
    label6.setText("B");
    vertLayout.setLabel("A B Vertical");
    vertLayout.addItemListener(new java.awt.event.ItemListener() {
      public void itemStateChanged(ItemEvent e) {
        vertLayout_itemStateChanged(e);
      }
    });
    horizLayout.setLabel("A B Horizontal");
    horizLayout.addItemListener(new java.awt.event.ItemListener() {
      public void itemStateChanged(ItemEvent e) {
        horizLayout_itemStateChanged(e);
      }
    });
    aOnlyLayout.setLabel("A Only");
    aOnlyLayout.addItemListener(new java.awt.event.ItemListener() {
      public void itemStateChanged(ItemEvent e) {
        aOnlyLayout_itemStateChanged(e);
      }
    });
    bOnlyLayout.setLabel("B Only");
    bOnlyLayout.addItemListener(new java.awt.event.ItemListener() {
      public void itemStateChanged(ItemEvent e) {
        bOnlyLayout_itemStateChanged(e);
      }
    });

    //GUI for Category B Properties
    centerOffsetB.setLabel("Center Offset");
    centerOffsetB.addItemListener(new java.awt.event.ItemListener() {
      public void itemStateChanged(ItemEvent e) {
        centerOffsetB_itemStateChanged(e);
      }
    });
    groupBox2.setLayout(xYLayout12);
    groupBox2.setLabel("Category B");
    scaleOneB.setLabel("Scale = 1");
    scaleOneB.addItemListener(new java.awt.event.ItemListener() {
      public void itemStateChanged(ItemEvent e) {
        scaleOneB_itemStateChanged(e);
      }
    });
    scaleIncreaseB.setLabel("Scale*2");
    scaleIncreaseB.addItemListener(new java.awt.event.ItemListener() {
      public void itemStateChanged(ItemEvent e) {
        scaleIncreaseB_itemStateChanged(e);
      }
    });
    scaleDecreaseB.setLabel("Scale/2");
    scaleDecreaseB.addItemListener(new java.awt.event.ItemListener() {
      public void itemStateChanged(ItemEvent e) {
        scaleDecreaseB_itemStateChanged(e);
      }
    });

    //GUI for Category A Properties
    groupBox3.setLabel("Category A");
    groupBox3.setLayout(xYLayout13);
    scaleDecreaseA.setLabel("Scale/2");
    scaleDecreaseA.addItemListener(new java.awt.event.ItemListener() {
      public void itemStateChanged(ItemEvent e) {
        scaleDecreaseA_itemStateChanged(e);
      }
    });
    scaleOneA.setLabel("Scale = 1");
    scaleOneA.addItemListener(new java.awt.event.ItemListener() {
      public void itemStateChanged(ItemEvent e) {
        scaleOneA_itemStateChanged(e);
      }
    });
    scaleIncreaseA.setLabel("Scale*2");
    scaleIncreaseA.addItemListener(new java.awt.event.ItemListener() {
      public void itemStateChanged(ItemEvent e) {
        scaleIncreaseA_itemStateChanged(e);
      }
    });
    setFontA.setLabel("Set Font");
    setFontA.addItemListener(new java.awt.event.ItemListener() {
      public void itemStateChanged(ItemEvent e) {
        setFontA_itemStateChanged(e);
      }
    });
    centerOffsetA.setLabel("Center Offset");
    centerOffsetA.addItemListener(new java.awt.event.ItemListener() {
      public void itemStateChanged(ItemEvent e) {
        centerOffsetA_itemStateChanged(e);
      }
    });
    //Location of GUI Components in Functor
    //Graphical Settings
    label4.setFont(new Font("Dialog", 1, 12));
    label3.setFont(new Font("Dialog", 1, 12));
    label2.setFont(new Font("Dialog", 1, 12));

    this.add(okButton, new XYConstraints(328, 351, 145, 31));
    this.add(groupBox1, new XYConstraints(10, 193, 469, 156));
    groupBox1.add(panel1, new XYConstraints(6, 16, 37, 63));
    panel1.add(label4, new XYConstraints(13, 20, 19, -1));
    groupBox1.add(panel2, new XYConstraints(52, 16, 38, 63));
    panel2.add(label6, new XYConstraints(14, 21, 15, -1));
    groupBox1.add(panel3, new XYConstraints(128, 14, 75, 29));
    panel3.add(label3, new XYConstraints(32, 4, 19, -1));
    groupBox1.add(panel4, new XYConstraints(128, 51, 75, 30));
    panel4.add(label5, new XYConstraints(32, 4, 15, -1));
    groupBox1.add(panel5, new XYConstraints(239, 13, 76, 66));
    panel5.add(label1, new XYConstraints(33, 22, 19, -1));
    groupBox1.add(panel6, new XYConstraints(348, 14, 76, 66));
    panel6.add(label2, new XYConstraints(35, 22, 15, -1));
    groupBox1.add(vertLayout, new XYConstraints(6, 93, 88, -1));
    groupBox1.add(horizLayout, new XYConstraints(127, 93, -1, -1));
    groupBox1.add(aOnlyLayout, new XYConstraints(239, 92, -1, -1));
    groupBox1.add(bOnlyLayout, new XYConstraints(347, 91, -1, -1));
    this.add(groupBox2, new XYConstraints(247, 15, 228, 174));
    groupBox2.add(setFontB, new XYConstraints(9, 123, -1, -1));
    groupBox2.add(centerOffsetB, new XYConstraints(9, 98, -1, -1));
    groupBox2.add(scaleDecreaseB, new XYConstraints(9, 13, -1, -1));
    groupBox2.add(scaleOneB, new XYConstraints(9, 39, -1, -1));
    groupBox2.add(scaleIncreaseB, new XYConstraints(9, 64, -1, -1));
    this.add(groupBox3, new XYConstraints(12, 14, 218, 174));
    groupBox3.add(setFontA, new XYConstraints(2, 125, -1, -1));
    groupBox3.add(centerOffsetA, new XYConstraints(2, 97, -1, -1));
    groupBox3.add(scaleDecreaseA, new XYConstraints(3, 17, -1, -1));
    groupBox3.add(scaleOneA, new XYConstraints(3, 41, -1, -1));
    groupBox3.add(scaleIncreaseA, new XYConstraints(2, 65, -1, -1));
    if (ed.scale_ == 1)
      scaleOneB.setState(true);
    else
    {
      //scaleOtherB.setState(true);
      //scaleFieldB.setText(ed.scale_ + "");
    }

    setFontB.setLabel("Set Font");
    setFontB.addItemListener(new java.awt.event.ItemListener() {
      public void itemStateChanged(ItemEvent e) {
        setFontB_itemStateChanged(e);
      }
    });
    if (ed.displayType == 'v')
      LayoutGroup.setCurrent(vertLayout);
    else if (ed.displayType == 'h')
      LayoutGroup.setCurrent(horizLayout);
    else if (ed.displayType == 'a')
      LayoutGroup.setCurrent(aOnlyLayout);
    else if (ed.displayType == 'b')
      LayoutGroup.setCurrent(bOnlyLayout);
 }

  void centerOffsetA_itemStateChanged(ItemEvent e)
  //This function is called when the center offset option
  //is selected for Category A
  {
    DDimension port_dim = ed.functorFromPanel.getPortSize();
    DDimension cont_dim = ed.functorFromPanel.getContentSize();

    double x = (cont_dim.width - port_dim.width) / 2.0;
    double y = (cont_dim.height - port_dim.height) / 2.0;

    ed.functorFromPanel.scrollTo((int)x, (int)y);
  }


  void centerOffsetB_itemStateChanged(ItemEvent e)
  //This function is called when the center offset option
  //is selected for Category B
  {
    DDimension port_dim = ed.functorToPanel.getPortSize();
    DDimension cont_dim = ed.functorToPanel.getContentSize();

    double x = (cont_dim.width - port_dim.width) / 2.0;
    double y = (cont_dim.height - port_dim.height) / 2.0;

    ed.functorToPanel.scrollTo((int)x, (int)y);
  }

  void setFontA_itemStateChanged(ItemEvent e)
  //This option displays a font dialog window when the Font
  //Settings option is selected for Category A
  {
    if(ed.functorFromFont == null)
      ed.functorFromFont = new FontPropDialog(ed, ed.functorFromCanvas);
    else
      ed.functorFromFont.showMe();
  }

  void setFontB_itemStateChanged(ItemEvent e)
  //This option displays a font dialog window when the Font
  //Settings option is selected for Category B
  {
    if(ed.functorToFont == null)
      ed.functorToFont = new FontPropDialog(ed, ed.functorToCanvas);
    else
      ed.functorToFont.showMe();
  }

  void scaleDecreaseA_itemStateChanged(ItemEvent e)
  //Selected when the user decides to make scale = scale/2
  //for Category A
  {
    ed.functorFromScale /= 2.0;
    ed.functorFromCanvas.setScale(ed.functorFromScale);
  }

  void scaleDecreaseB_itemStateChanged(ItemEvent e)
  //Selected when the user decides to make scale = scale/2
  //for Category B
  {
    ed.functorToScale /= 2.0;
    ed.functorToCanvas.setScale(ed.functorToScale);
  }


  void scaleOneA_itemStateChanged(ItemEvent e)
  //Selected when the user decides to make scale = 1
  //for Category B
  {
    ed.functorFromScale = 1.0;
    ed.functorFromCanvas.setScale(ed.functorFromScale);
  }

  void scaleOneB_itemStateChanged(ItemEvent e)
  //Selected when the user decides to make scale = 1
  //for Category B
  {
    ed.functorToScale = 1.0;
    ed.functorToCanvas.setScale(ed.functorToScale);
  }

  void scaleIncreaseA_itemStateChanged(ItemEvent e)
  //Selected when the user decides to make scale = scale*2
  //for Category A
  {
    ed.functorFromScale *= 2.0;
    ed.functorFromCanvas.setScale(ed.functorFromScale);
  }

  void scaleIncreaseB_itemStateChanged(ItemEvent e)
  //Selected when the user decides to make scale = scale*2
  //for Category B
  {
    ed.scale_ *= 2.0;
    ed.functorToCanvas.setScale(ed.scale_);
  }

  void horizLayout_itemStateChanged(ItemEvent e)
  //Display categories a and b one on top of the other for
  //functor category display
  {
    if (ed.displayType != 'h')
    {
      //Make categories a and b visible if necessary
      if (ed.displayType == 'a')
      {
        ed.funcPanel1.setVisible(true);
        ed.validate();
      }
      else if (ed.displayType == 'b')
      {
        ed.funcPanel2.setVisible(true);
        ed.validate();
      }
      //Redraw Layout of categories horizontally
      ed.createFunctorDisplay.removeAll();
      ed.createFunctorDisplay.add(ed.funcPanel1, new GridBagConstraints2(0, 0, 1, 1, 1.0, 1.0,GridBagConstraints.CENTER, GridBagConstraints.BOTH, new Insets(6, 5, 0, 4), 639, 227));
      ed.createFunctorDisplay.add(ed.funcPanel2, new GridBagConstraints2(0, 1, 1, 1, 1.0, 1.0,GridBagConstraints.CENTER, GridBagConstraints.BOTH, new Insets(0, 5, 0, 3), 638, 245));
      ed.createFunctorDisplay.add(ed.funcDisplayControls, new GridBagConstraints2(0, 2, 1, 1, 0.0, 0.0,GridBagConstraints.CENTER, GridBagConstraints.BOTH, new Insets(6, 5, 3, 4), 183, 4));
      ed.validate();
      ed.displayType = 'h';
    }
  }

  void vertLayout_itemStateChanged(ItemEvent e)
  //Display categories a and b side by side for functor category display
  {
    if (ed.displayType == 'a')
      ed.funcPanel1.setVisible(true);
    else if (ed.displayType == 'b')
      ed.funcPanel2.setVisible(true);
    else if (ed.displayType == 'h')
    {
      ed.createFunctorDisplay.removeAll();
      ed.createFunctorDisplay.add(ed.funcPanel1, new GridBagConstraints2(0, 0, 1, 1, 1.0, 1.0,GridBagConstraints.CENTER, GridBagConstraints.BOTH, new Insets(6, 5, 0, 0), 314, 487));
      ed.createFunctorDisplay.add(ed.funcPanel2, new GridBagConstraints2(1, 0, 1, 1, 1.0, 1.0,GridBagConstraints.CENTER, GridBagConstraints.BOTH, new Insets(6, 14, 0, 3), 302, 487));
      ed.createFunctorDisplay.add(ed.funcDisplayControls, new GridBagConstraints2(0, 1, 2, 1, 0.0, 0.0,GridBagConstraints.CENTER, GridBagConstraints.BOTH, new Insets(6, 5, 3, 4), 182, 4));
    }
    ed.validate();
    ed.displayType = 'v';
  }

  void aOnlyLayout_itemStateChanged(ItemEvent e)
  //Display category a only for functor category display
  {
    if (ed.displayType == 'h')
    {
      ed.createFunctorDisplay.removeAll();
      ed.createFunctorDisplay.add(ed.funcPanel1, new GridBagConstraints2(0, 0, 1, 1, 1.0, 1.0,GridBagConstraints.CENTER, GridBagConstraints.BOTH, new Insets(6, 5, 0, 0), 314, 487));
      ed.createFunctorDisplay.add(ed.funcPanel2, new GridBagConstraints2(1, 0, 1, 1, 1.0, 1.0,GridBagConstraints.CENTER, GridBagConstraints.BOTH, new Insets(6, 14, 0, 3), 302, 487));
      ed.createFunctorDisplay.add(ed.funcDisplayControls, new GridBagConstraints2(0, 1, 2, 1, 0.0, 0.0,GridBagConstraints.CENTER, GridBagConstraints.BOTH, new Insets(6, 5, 3, 4), 182, 4));
      ed.funcPanel1.setVisible(false);
    }
    else if (ed.displayType == 'b')
    {
      ed.funcPanel2.setVisible(true);
      ed.funcPanel1.setVisible(false);
    }
    else if (ed.displayType == 'v')
      ed.funcPanel1.setVisible(false);
    ed.validate();
    ed.displayType = 'a';
  }

  void bOnlyLayout_itemStateChanged(ItemEvent e)
  //Display category b only for functor category display
  {
    if (ed.displayType == 'h')
    {
      ed.createFunctorDisplay.removeAll();
      ed.createFunctorDisplay.add(ed.funcPanel1, new GridBagConstraints2(0, 0, 1, 1, 1.0, 1.0,GridBagConstraints.CENTER, GridBagConstraints.BOTH, new Insets(6, 5, 0, 0), 314, 487));
      ed.createFunctorDisplay.add(ed.funcPanel2, new GridBagConstraints2(1, 0, 1, 1, 1.0, 1.0,GridBagConstraints.CENTER, GridBagConstraints.BOTH, new Insets(6, 14, 0, 3), 302, 487));
      ed.createFunctorDisplay.add(ed.funcDisplayControls, new GridBagConstraints2(0, 1, 2, 1, 0.0, 0.0,GridBagConstraints.CENTER, GridBagConstraints.BOTH, new Insets(6, 5, 3, 4), 182, 4));
      ed.funcPanel2.setVisible(false);
    }
    if (ed.displayType == 'a')
    {
      ed.funcPanel1.setVisible(true);
      ed.funcPanel2.setVisible(false);
    }
    else if (ed.displayType == 'v')
      ed.funcPanel2.setVisible(false);
    ed.validate();
    ed.displayType = 'b';
  }
}
