 /*
Research Project:   Category Theory Database Tools
                    J. Bradbury, Dr. R. Rosebrugh
                    Mount Allison University 1999
File:               SettingsGraphical.java
Description:	      This file creates a frame that allows the user to change
                    certain graphical settings in the display of a category
*/

//import statements
import java.awt.*;
import borland.jbcl.layout.*;
import java.awt.event.*;
import borland.jbcl.control.*;

public class SettingsGraphical extends Frame {

  Category c = new Category();
  DefList l = new DefList();
  int check_enter = 0;

  //Objects in the Graphical User Interface(GUI)
  Button exit = new Button();
  Panel button_panel = new Panel();
  BorderLayout borderLayout1 = new BorderLayout();
  XYLayout xYLayout1 = new XYLayout();
  Button okButton = new Button();
  GroupBox offsetBox = new GroupBox();
  XYLayout xYLayout3 = new XYLayout();
  GroupBox scaleBox = new GroupBox();
  CheckboxGroup checkboxGroup1 = new CheckboxGroup();
  Checkbox showControls = new Checkbox();
  GroupBox displayBox = new GroupBox();
  XYLayout xYLayout4 = new XYLayout();
  CheckboxGroup scaleGroup = new CheckboxGroup();
  CheckboxGroup planeGroup = new CheckboxGroup();
  Checkbox setFont = new Checkbox();
  Checkbox scaleDecrease = new Checkbox("", scaleGroup, false);
  Checkbox scaleOther = new Checkbox("", scaleGroup, false);
  Checkbox scaleIncrease = new Checkbox("", scaleGroup, false);
  Checkbox scaleOne = new Checkbox("", scaleGroup, false);
  XYLayout xYLayout5 = new XYLayout();
  TextField scaleField = new TextField();
  Checkbox centerOffset = new Checkbox();
  MainWindow ed = new MainWindow();


  public SettingsGraphical(MainWindow edit)
  //Default Constructor with the parent frame as a parameter
  {
    ed = edit;
    try  {
      jbInit();
    }
    catch (Exception e) {
      e.printStackTrace();
    }
  }

  public boolean handleEvent(Event e)
  {
    if ((e.id == Event.WINDOW_DESTROY) || (e.id == Event.ACTION_EVENT))
    {
     hide();            //hide frame
     dispose();         //free resources
     return true;
    }
    else if (e.key == Event.ENTER)
    {
      if (check_enter == 0)
       check_enter++;
      else
      {
       hide();            //hide frame
       dispose();         //free resources
      }
      return true;
    }
    return super.handleEvent(e);
  }

 public boolean action(Event e, Object o)
 {
  if ((e.target == exit) || (e.key == Event.ENTER))
  {
   hide();            //hide frame
   dispose();         //free resources
   return true;
  }
  return false;
 }


 private void jbInit() throws Exception
 //This function intializes the GUI
 {
    this.setTitle("GDCT: Graphical Settings");
    this.setBackground(new Color(192,192,192));
    xYLayout1.setHeight(218);
    okButton.setLabel("OK");
    xYLayout1.setWidth(404);
    okButton.setLabel("OK");
    this.setLayout(xYLayout1);
    centerOffset.setLabel("Center Offset");
    centerOffset.addItemListener(new java.awt.event.ItemListener() {
      public void itemStateChanged(ItemEvent e) {
        centerOffset_itemStateChanged(e);
      }
    });
    offsetBox.setLabel("Viewing Offset");
    scaleField.setBackground(Color.white);
    offsetBox.setLayout(xYLayout3);
    displayBox.setLayout(xYLayout4);
    scaleBox.setLayout(xYLayout5);
    this.add(okButton, new XYConstraints(240, 152, 145, 31));
    this.add(offsetBox, new XYConstraints(228, 9, 161, 58));
    offsetBox.add(centerOffset, new XYConstraints(13, 5, -1, -1));
    this.add(scaleBox, new XYConstraints(6, 9, 218, 144));
    scaleBox.add(scaleDecrease, new XYConstraints(16, 5, -1, -1));
    scaleBox.add(scaleOther, new XYConstraints(16, 87, 65, -1));
    scaleBox.add(scaleIncrease, new XYConstraints(15, 60, -1, -1));
    scaleBox.add(scaleOne, new XYConstraints(15, 32, -1, -1));
    scaleBox.add(scaleField, new XYConstraints(80, 85, 43, -1));
    this.add(displayBox, new XYConstraints(227, 69, 162, 83));
    displayBox.add(showControls, new XYConstraints(15, 6, -1, -1));
    displayBox.add(setFont, new XYConstraints(16, 35, -1, -1));
    scaleOne.setLabel("Scale = 1");
    scaleOne.addItemListener(new java.awt.event.ItemListener() {
      public void itemStateChanged(ItemEvent e) {
        scaleOne_itemStateChanged(e);
      }
    });
    scaleIncrease.setLabel("Scale*2");
    scaleIncrease.addItemListener(new java.awt.event.ItemListener() {
      public void itemStateChanged(ItemEvent e) {
        scaleIncrease_itemStateChanged(e);
      }
    });
    scaleOther.setLabel("Scale = ");
    scaleOther.addItemListener(new java.awt.event.ItemListener() {
      public void itemStateChanged(ItemEvent e) {
        scaleOther_itemStateChanged(e);
      }
    });
    scaleDecrease.setLabel("Scale/2");
    scaleDecrease.addItemListener(new java.awt.event.ItemListener() {
      public void itemStateChanged(ItemEvent e) {
        scaleDecrease_itemStateChanged(e);
      }
    });
    if (ed.scale_ == 1)
      scaleOne.setState(true);
    else
    {
      scaleOther.setState(true);
      scaleField.setText(ed.scale_ + "");
    }

    setFont.setLabel("Set Font");
    setFont.addItemListener(new java.awt.event.ItemListener() {
      public void itemStateChanged(ItemEvent e) {
        setFont_itemStateChanged(e);
      }
    });
    displayBox.setLabel("Display");
    showControls.setLabel("Show Controls");
    if (ed.showControlsMenuItem.getState())
      showControls.setState(true);
    else
      showControls.setState(false);
    showControls.addItemListener(new java.awt.event.ItemListener() {
      public void itemStateChanged(ItemEvent e) {
        showControls_itemStateChanged(e);
      }
    });
    scaleBox.setLabel("Scale");


 }

  void showControls_itemStateChanged(ItemEvent e)
  //This function is called when the show controls option is selected
  {
    if (showControls.getState())
  	  ed.t.show();
    else
		  ed.t.hide();
    ed.validate();
  }

  void centerOffset_itemStateChanged(ItemEvent e)
  //This function is called when the center offset option
  //is selected
  {
    DDimension port_dim = ed.viewingPanel_.getPortSize();
    DDimension cont_dim = ed.viewingPanel_.getContentSize();

    double x = (cont_dim.width - port_dim.width) / 2.0;
    double y = (cont_dim.height - port_dim.height) / 2.0;

    ed.viewingPanel_.scrollTo((int)x, (int)y);
    ed.portScroller_.setOffset(x, y);
  }

  void setFont_itemStateChanged(ItemEvent e)
  //This option displays a font dialog window when the Font
  //Settings option is selected
  {
    if(ed.fontPropDialog_ == null)
      ed.fontPropDialog_ = new FontPropDialog(ed, ed.graphCanvas_);
    else
      ed.fontPropDialog_.showMe();
  }

  void scaleDecrease_itemStateChanged(ItemEvent e)
  //Selected when the user decides to make scale = scale/2
  {
    ed.scale_ /= 2.0;
    ed.graphCanvas_.setScale(ed.scale_);
    ed.scaleLabel_.setText("Scale: " + ed.scale_);
  }

  void scaleOne_itemStateChanged(ItemEvent e)
  //Selected when the user decides to make scale = 1
  {
    ed.scale_ = 1.0;
    ed.graphCanvas_.setScale(ed.scale_);
    ed.scaleLabel_.setText("Scale: " + ed.scale_);
  }

  void scaleIncrease_itemStateChanged(ItemEvent e)
  //Selected when the user decides to make scale = scale*2
  {
    ed.scale_ *= 2.0;
    ed.graphCanvas_.setScale(ed.scale_);
    ed.scaleLabel_.setText("Scale: " + ed.scale_);
  }

  void scaleOther_itemStateChanged(ItemEvent e)
  //Selected when the user decides to make scale = value of scaleField
  {
    try
    {
      ed.scale_ = Integer.parseInt(scaleField.getText());
      ed.graphCanvas_.setScale(ed.scale_);
      ed.scaleLabel_.setText("Scale: " + ed.scale_);
    }
    catch (NumberFormatException e1)
    {
      new MessageDialog(this, "Error", "Scale value must be an integer", true);
    }
  }
}

