 /*
Research Project:   Category Theory Database Tools
                    J. Bradbury, Dr. R. Rosebrugh
                    Mount Allison University 1999
File:               SettingServer.java
Description:        This class displays a frame which allows the user to
                    change the default server, default server category directory,
                    and the default server functor directory, which are used in
                    the loading of files. 
*/

//import statements
import java.awt.*;
import borland.jbcl.layout.*;
import java.awt.event.*;
import borland.jbcl.control.*;

public class SettingsServer extends Frame {

  Category c = new Category();
  DefList l = new DefList();
  int check_enter = 0;

  //Objects in the Graphical User Interface(GUI)
  Button exit = new Button();
  Panel button_panel = new Panel();
  BorderLayout borderLayout1 = new BorderLayout();
  XYLayout xYLayout1 = new XYLayout();
  Button okButton = new Button();
  MainWindow ed = new MainWindow();
  GroupBox groupBox1 = new GroupBox();
  XYLayout xYLayout2 = new XYLayout();
  Label serverLabel = new Label();
  Label catLabel = new Label();
  Label funLabel = new Label();
  TextField serverField = new TextField();
  TextField catField = new TextField();
  TextField funField = new TextField();
  Checkbox defaultBox = new Checkbox();
  TextField cglField = new TextField();
  TextField fglField = new TextField();
  Label cglLabel = new Label();
  Label fglLabel = new Label();


  public SettingsServer(MainWindow edit)
  //Default Constructor with the parent frame as a parameter
  {
    ed = edit;
    try  {
      jbInit();
    }
    catch (Exception e) {
      e.printStackTrace();
    }
  }

  public boolean handleEvent(Event e)
  {
    if ((e.id == Event.WINDOW_DESTROY) || (e.id == Event.ACTION_EVENT))
    {
     hide();            //hide frame
     dispose();         //free resources
     return true;
    }
    else if (e.key == Event.ENTER)
    {
      if (check_enter == 0)
       check_enter++;
      else
      {
       hide();            //hide frame
       dispose();         //free resources
      }
      return true;
    }
    return super.handleEvent(e);
  }

 public boolean action(Event e, Object o)
 {
  if ((e.target == exit) || (e.key == Event.ENTER))
  {
   hide();            //hide frame
   dispose();         //free resources
   return true;
  }
  return false;
 }


 private void jbInit() throws Exception
 //This function intializes the GUI
 {
    this.setTitle("GDCT: Server Settings");
    this.setBackground(new Color(192,192,192));
    xYLayout1.setHeight(450);
    okButton.setLabel("OK");
    xYLayout1.setWidth(406);
    okButton.setLabel("OK");
    okButton.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        okButton_actionPerformed(e);
      }
    });
    serverLabel.setText("Server Address:");
    catLabel.setText("CAT File Directory: ");
    funLabel.setText("FUN File Directory:");
    cglField.setBackground(Color.white);
    fglField.setBackground(Color.white);
    cglLabel.setText("CGL File Directory: ");
    fglLabel.setText("FGL File Directory: ");
    fglField.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        fglField_actionPerformed(e);
      }
    });
    defaultBox.setLabel("Use Default Settings");


    defaultBox.addItemListener(new java.awt.event.ItemListener() {
      public void itemStateChanged(ItemEvent e) {
        defaultBox_itemStateChanged(e);
      }
    });
    groupBox1.setLayout(xYLayout2);
    this.setLayout(xYLayout1);
    serverField.setBackground(Color.white);
    catField.setBackground(Color.white);
    funField.setBackground(Color.white);
    this.add(okButton, new XYConstraints(242, 242, 145, 31));
    this.add(groupBox1, new XYConstraints(14, 13, 378, -1));
    groupBox1.add(serverLabel, new XYConstraints(0, 5, 104, 30));
    groupBox1.add(catLabel, new XYConstraints(-1, 38, 113, -1));
    groupBox1.add(funLabel, new XYConstraints(1, 110, 104, -1));
    groupBox1.add(serverField, new XYConstraints(115, 4, 230, -1));
    groupBox1.add(catField, new XYConstraints(115, 37, 231, -1));
    groupBox1.add(funField, new XYConstraints(116, 105, 230, -1));
    groupBox1.add(defaultBox, new XYConstraints(115, 171, 181, -1));
    groupBox1.add(fglField, new XYConstraints(116, 140, 231, -1));
    groupBox1.add(cglField, new XYConstraints(115, 70, 231, -1));
    groupBox1.add(cglLabel, new XYConstraints(-1, 73, 113, -1));
    groupBox1.add(fglLabel, new XYConstraints(1, 143, 113, -1));
    serverField.setText(ed.cons.server);
    catField.setText(ed.cons.catdir);
    cglField.setText(ed.cons.cgldir);
    funField.setText(ed.cons.fundir);
    fglField.setText(ed.cons.fgldir);

    funField.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        functorField_actionPerformed(e);
      }
    });
  }

  void okButton_actionPerformed(ActionEvent e) {
    ed.cons.server = serverField.getText();
    ed.cons.catdir = catField.getText();
    ed.cons.cgldir = cglField.getText();
    ed.cons.fundir = funField.getText();
    ed.cons.fgldir = fglField.getText();
    hide();
    dispose();
  }

  void defaultBox_itemStateChanged(ItemEvent e) {
    serverField.setText(ed.cons.server);
    catField.setText(ed.cons.catdir);
    cglField.setText(ed.cons.cgldir);
    funField.setText(ed.cons.fundir);
    fglField.setText(ed.cons.fgldir);
    defaultBox.setState(false);
  }

  void choice1_itemStateChanged(ItemEvent e) {

  }

  void functorField_actionPerformed(ActionEvent e) {

  }

  void fglField_actionPerformed(ActionEvent e) {

  }

}
