 /*
Research Project:   Category Theory Database Tools
                    J. Bradbury, Dr. R. Rosebrugh
                    Mount Allison University 1999
File:               SettingsText.java
Description:        This class displays a frame that allows the user to change
                    the font as well as change the style and size of the font.
*/

//import statements
import java.awt.*;
import borland.jbcl.layout.*;
import java.awt.event.*;
import borland.jbcl.control.*;

public class SettingsText extends Frame {

  Category c = new Category();
  DefList l = new DefList();
  int check_enter = 0;

  //Objects in the Graphical User Interface(GUI)
  Button exit = new Button();
  XYLayout xYLayout1 = new XYLayout();
  MainWindow ed = new MainWindow();
  GroupBox groupBox1 = new GroupBox();
  Checkbox createCategoryBox = new Checkbox();
  Checkbox displayCategoryBox = new Checkbox();
  Checkbox createFunctorBox = new Checkbox();
  Checkbox displayFunctorBox = new Checkbox();
  XYLayout xYLayout2 = new XYLayout();
  Button fontButton = new Button();
  Button okButton = new Button();
  Label createCategoryLabel = new Label();
  Label displayCategoryLabel = new Label();
  Label createFunctorLabel = new Label();
  Label displayFunctorLabel = new Label();
  FontChooser fontChooser1 = new FontChooser();


  public SettingsText(MainWindow edit)
  //Default Constructor with the parent frame as a parameter
  {
    ed = edit;
    try  {
      jbInit();
    }
    catch (Exception e) {
      e.printStackTrace();
    }
  }

  public boolean handleEvent(Event e)
  {
    if ((e.id == Event.WINDOW_DESTROY))//|| (e.id == Event.ACTION_EVENT))
    {
     hide();            //hide frame
     dispose();         //free resources
     return true;
    }
    /*else if (e.key == Event.ENTER)
    {
      if (check_enter == 0)
       check_enter++;
      else
      {
       hide();            //hide frame
       dispose();         //free resources
      }
      return true;
    } */
    return super.handleEvent(e);
  }

 public boolean action(Event e, Object o)
 {
  if ((e.target == exit) || (e.key == Event.ENTER))
  {
   hide();            //hide frame
   dispose();         //free resources
   return true;
  }
  return false;
 }


 private void jbInit() throws Exception
 //This function intializes the GUI
 {
    this.setTitle("GDCT: Text Settings");
    this.setBackground(new Color(192,192,192));
    xYLayout1.setHeight(245);
    groupBox1.setLayout(xYLayout2);
    groupBox1.setLabel("Text Areas");
    Font f = ed.objectArea.getFont();

    createCategoryBox.setLabel("Create Category Text");
    displayCategoryBox.setLabel("Display Category Text");
    createFunctorBox.setLabel("Create Functor Text");
    displayFunctorBox.setLabel("Display Functor Text");
    createCategoryLabel.setText(fontProperties(ed.viewbox));
    displayCategoryLabel.setText(fontProperties(ed.objectArea));
    createFunctorLabel.setText(fontProperties(ed.functorDisplayArea));
    displayFunctorLabel.setText(fontProperties(ed.functorObjectArea));
    okButton.setLabel("OK");
    okButton.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        okButton_actionPerformed(e);
      }
    });
    createCategoryLabel.setFont(new Font("Dialog", 0, 12));
    displayCategoryLabel.setFont(new Font("Dialog", 0, 12));
    createFunctorLabel.setFont(new Font("Dialog", 0, 12));
    displayFunctorLabel.setFont(new Font("Dialog", 0, 12));
    fontButton.setLabel("Set Font");
    fontButton.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        fontButton_actionPerformed(e);
      }
    });
    xYLayout1.setWidth(504);
    this.setLayout(xYLayout1);
    this.add(groupBox1, new XYConstraints(16, 17, 467, 143));
    groupBox1.add(createCategoryBox, new XYConstraints(15, 5, -1, -1));
    groupBox1.add(displayCategoryBox, new XYConstraints(15, 33, -1, -1));
    groupBox1.add(createFunctorBox, new XYConstraints(15, 61, -1, -1));
    groupBox1.add(displayFunctorBox, new XYConstraints(15, 88, -1, -1));
    groupBox1.add(createCategoryLabel, new XYConstraints(180, 7, 253, 19));
    groupBox1.add(displayCategoryLabel, new XYConstraints(180, 33, 258, 21));
    groupBox1.add(createFunctorLabel, new XYConstraints(181, 59, 257, 21));
    groupBox1.add(displayFunctorLabel, new XYConstraints(182, 88, 257, -1));
    this.add(fontButton, new XYConstraints(183, 170, 147, 32));
    this.add(okButton, new XYConstraints(337, 170, 140, 31));
 }

 String fontProperties(TextArea t)
 //This method returns a sting containing the font
 //properties of the given TextArea
 {
    String temp = t.getFont().toString();
    int i = 0;
    boolean firstComma = false;
    int begin = 0;
    int end = 0;

    while ((temp.charAt(i) != ']') && (i != temp.length()))
    {
      if ((temp.charAt(i) == ',') && (firstComma == false))
      {
        begin = i + 1;
        firstComma = true;
      }
      i++;
    }
    end = i;

    return("[ " + temp.substring(begin, end) + " ]");
 }

  void okButton_actionPerformed(ActionEvent e)
  //This method is called when the "OK" button is pressed
  //It closes the text settings frame
  {
   hide();            //hide frame
   dispose();         //free resources
  }

  void fontButton_actionPerformed(ActionEvent e)
  //This method is called when the "Set Font" button is pressed
  {
    if (createCategoryBox.getState() == true)
    {
        fontChooser1.setFrame(this);
        fontChooser1.setTitle("Create Category Font");
        fontChooser1.show();
        ed.viewbox.setFont(fontChooser1.getValue());
        ed.categoryNameField.setFont(fontChooser1.getValue());
        ed.catInputField.setFont(fontChooser1.getValue());
        createCategoryBox.setState(false);
        createCategoryLabel.setText(fontProperties(ed.viewbox));
        validate();
    }
    if (displayCategoryBox.getState() == true)
    {
        fontChooser1.setFrame(this);
        fontChooser1.setTitle("Display Category Font");
        fontChooser1.show();
        ed.categoryChoice.setFont(fontChooser1.getValue());
        ed.objectArea.setFont(fontChooser1.getValue());
        ed.arrowArea.setFont(fontChooser1.getValue());
        ed.relationArea.setFont(fontChooser1.getValue());
        ed.commentArea.setFont(fontChooser1.getValue());
        displayCategoryBox.setState(false);
        displayCategoryLabel.setText(fontProperties(ed.objectArea));
        validate();
    }
    if (createFunctorBox.getState() == true)
    {
        fontChooser1.setFrame(this);
        fontChooser1.setTitle("Create Category Font");
        fontChooser1.show();
        ed.functorInputField.setFont(fontChooser1.getValue());
        ed.functorToChoice.setFont(fontChooser1.getValue());
        ed.functorFromChoice.setFont(fontChooser1.getValue());
        ed.functorNameField.setFont(fontChooser1.getValue());
        ed.functorDisplayArea.setFont(fontChooser1.getValue());
        createFunctorBox.setState(false);
        createFunctorLabel.setText(fontProperties(ed.functorDisplayArea));
        validate();
    }
    if (displayFunctorBox.getState() == true)
    {
        fontChooser1.setFrame(this);
        fontChooser1.setTitle("Display Functor Font");
        fontChooser1.show();
        ed.functorChoice.setFont(fontChooser1.getValue());
        ed.functorObjectArea.setFont(fontChooser1.getValue());
        ed.functorArrowArea.setFont(fontChooser1.getValue());
        displayFunctorBox.setState(false);
        displayFunctorLabel.setText(fontProperties(ed.functorObjectArea));
        validate();
    }
  }

}
