/*
Research Project:   Category Theory Database Tools
                    J. Bradbury, Dr. R. Rosebrugh
                    Mount Allison University 1998
File:               StringChecker.java
Description:	      This class checks strings that are inputed by the user
                    to determine if they contain any characters or words
                    which are not allowed.
*/


public class StringChecker
{
  Constants cons = new Constants();
  MainWindow mw = new MainWindow();

  //Special words that are not allowed to be inputed by the user
  String specialStrings [] = {"category", "objects", "arrows", "relations", "functor", "gml"};
  int sLength = 6;

  //Special characters that are not allowed to appear anywhere in a user
  //entered string of text
  char specialChars [] = {cons.separator, '#', '.', ',', ' ', ':', '-', '>', '(', ')', '='};
  int cLength = 11;

  public StringChecker(MainWindow m)
  //Default constructor
  {
    mw = m;
  }

  boolean checkStrings(String text, MainWindow mw)
  //This method checks the string text to determine if it is the same as any of
  //strings defined as special strings. It returns true if string is ok and false
  //if string contains one of the special strings
  {
    text = text.toLowerCase();
    for (int i =0 ; i < sLength; i++)
    {
      if (text.equals(specialStrings[i]))
      {
        new MessageDialog(mw, "Error", text + " is a special word and can not be used.", true);
        return false;
      }
    }
    return true;
  }

  boolean checkChars(String text, MainWindow mw)
  //This method checks the string text to determine if it it contains any
  //of the special characters defined above. It returns true if string is
  //ok and false if string contains one of the special characters
  {
    for (int i =0 ; i < cLength; i++)
    {
      for (int j=0; j < text.length(); j++)
      {
        if (text.charAt(j) == (specialChars[i]))
        {
          new MessageDialog(mw, "Error", text + " contains the special character " + text.charAt(j) + " and can not be used.", true);
          return false;
        }
      }
    }
    return true;
  }

  boolean check(String text, MainWindow mw)
  //Check string for special words and characters
  {
    //boolean variables
    boolean s = false;
    boolean c = false;

    //check words and characters
    s = checkStrings(text, mw);
    c = checkChars(text, mw);

    //return appropriate boolean expression
    if ((s == true) && (c == true))
      return true;
    else
      return false;
  }
}
