 /*
Research Project:   Category Theory Database Tools
                    J. Bradbury, Dr. R. Rosebrugh
                    Mount Allison University 1999
File:               SumFrame.java
Description:        This class implements a frame which allows the user to run
                    the category tool "Sum" on the current category.
*/

//import statements
import java.awt.*;
import borland.jbcl.layout.*;
import java.awt.event.*;
import borland.jbcl.control.*;

public class SumFrame extends Frame {

  //Category c = new Category();
  DefList l = new DefList();
  int check_enter = 0;
   tree t = new tree();
   int editoption = 0;
   Constants cons = new Constants();
   int MAXARR = cons.MAXARR;
  //Objects in the Graphical User Interface(GUI)
  Button exit = new Button();
  Panel button_panel = new Panel();
  BorderLayout borderLayout1 = new BorderLayout();
  XYLayout xYLayout1 = new XYLayout();
  Button okButton = new Button();
  MainWindow ed = new MainWindow();
    
    Label objectLabel = new Label();
  Label alphaLabel = new Label();
  Label betaLabel = new Label();
  Choice objectChoice = new Choice();


  public SumFrame(MainWindow edit)
  //Default Constructor with the parent frame as a parameter
  {
    ed = edit;
    try  {
      jbInit();
    }
    catch (Exception e) {
      e.printStackTrace();
    }
  }

  public boolean handleEvent(Event e)
  {
    if ((e.id == Event.WINDOW_DESTROY) || (e.id == Event.ACTION_EVENT))
    {
     hide();            //hide frame
     dispose();         //free resources
     return true;
    }
    else if (e.key == Event.ENTER)
    {
      if (check_enter == 0)
       check_enter++;
      else
      {
       hide();            //hide frame
       dispose();         //free resources
      }
      return true;
    }
    return super.handleEvent(e);
  }

 public boolean action(Event e, Object o)
 {
  if ((e.target == exit) || (e.key == Event.ENTER))
  {
   hide();            //hide frame
   dispose();         //free resources
   return true;
  }
  return false;
 }


 private void jbInit() throws Exception
 //This function intializes the GUI
 {
    this.setTitle("GDCT: Sum Category");
    this.setBackground(new Color(192,192,192));
    xYLayout1.setHeight(205);
    okButton.setLabel("OK");
    xYLayout1.setWidth(508);
    objectLabel.setText("Object of Sum:");
    alphaLabel.setText("First Injection:");
    betaLabel.setText("Second Injection:");
    objectChoice.setBackground(Color.white);
    categoryLabel.setText("Current Category:");
    viewbox.setBackground(Color.white);
    sumButton.setLabel("Sum?");
    alphaField.setBackground(Color.white);
    betaField.setBackground(Color.white);
    sumButton.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        sumButton_actionPerformed(e);
      }
    });
    /*objectChoice.addItemListener(new java.awt.event.ItemListener() {
      public void itemStateChanged(ItemEvent e) {
        objectChoice_itemStateChanged(e);
      }
    });*/
    okButton.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        okButton_actionPerformed(e);
      }
    });

    this.setLayout(xYLayout1);
    categoryField.setBackground(Color.white);
    this.add(okButton, new XYConstraints(109, 139, 101, 31));
    this.add(betaLabel, new XYConstraints(5, 107, 94, 25));
    this.add(alphaLabel, new XYConstraints(6, 71, 85, 31));
    this.add(objectLabel, new XYConstraints(3, 45, 89, 27));

    this.add(objectChoice, new XYConstraints(107, 43, 105, -1));
    this.add(categoryField, new XYConstraints(108, 11, 103, 25));
    this.add(categoryLabel, new XYConstraints(2, 15, 100, -1));
    this.add(viewbox, new XYConstraints(227, 9, 267, 161));
    this.add(sumButton, new XYConstraints(4, 139, 95, 31));
    this.add(alphaField, new XYConstraints(106, 73, 106, 26));
    this.add(betaField, new XYConstraints(106, 104, 107, 26));

    categoryField.setEditable(false);
    categoryField.setText(ed.cat.name);
    for (int i = 0; i < ed.cat.numobj; i++)
      objectChoice.addItem(ed.cat.obj[i]);
    if (objectChoice.getItemCount() == 0)
    {
      new MessageDialog(this, "Error", "Can not perform sum, category has 0 Objects", true);
    }
    /*for (int i = 0; i < ed.cat.numarr; i++)
    {
      if (ed.cat.obj[ed.cat.arr[i][1]].equals(objectChoice.getSelectedItem()))
      {
          alphaChoice.addItem(ed.cat.arrow[i] + ":" + ed.cat.obj[ed.cat.arr[i][0]] + "->" + ed.cat.obj[ed.cat.arr[i][1]]);
          betaChoice.addItem(ed.cat.arrow[i] + ":" + ed.cat.obj[ed.cat.arr[i][0]] + "->" + ed.cat.obj[ed.cat.arr[i][1]]);
      }
    } */
  }

  void sumButton_actionPerformed(ActionEvent e)
  //Determine the sum of the current object given
  //an alpha and beta value
  {
    sum(ed.cat);
  }

  void okButton_actionPerformed(ActionEvent e)
  //Exit sum frame and return to main frame
  {
    hide();
    dispose();
  }
  
//----------------
//SUM METHODS
//----------------

 public boolean check_oneone(int path[], int domain, int codomain, int objects[], nodetype gamalbet, Category A, int alpha[],int beta[],  nodetype gammatree, int maxloop)
 /*
 Parameters:
        path:   the current path
        domain: the current object of the path
        codomain:    the object we are trying to find all arrows to
        objects:  an array of integers which keeps the function from exceeding
                                the maximum number of loops
        gamalbet:   the first node of a tree returned with all gamma alphas,
              gamma betas - see check_one_one
        A:      the category being tested
        alpha:  first injection to the sumobj being tested
        beta:   second injection to the sumobj being tested
  gammatree: the tree of all arrows from sumobj to codomain

 Local Variables:
  number: stores the number of arrows from an object
        current_arrow:  stores the number of the current arrow in the path
        codom:  stores the codomain of the current arrow
        arrow_array:   contains all of the arrows from an object
        gamma:  an arrow from the sumobj being tested to codomain

 Purpose:
        To generate the reduced hom set from one object to another and check 1-1

 Design:
        Creates a tree gamalbet containing the reduced form
        of all the gamma_alphas and each gamma_alpha having a subtree which contains
        all of the gamma_betas paired with it.
 */
 {

  int i,j, number, current_arrow, codom;
  int arrow_array[] = new int [ed.cons.MAXARR];
  int gamma[] = new int[ed.cons.MAXWORD];
  int reduced_gamma[] = new int[ed.cons.MAXWORD];
  int reduced_gammabeta[] = new int[ed.cons.MAXWORD];
  int reduced_gammaalpha[] = new int[ed.cons.MAXWORD];
  nodetype theprev = new nodetype();
  nodetype temptree = new nodetype();
  nodetype tp = new nodetype();

  if((objects[domain] <= maxloop))
        {
        number = all_arr(A,domain,arrow_array); /*get all arrows from current object*/
        for(i=0;i<number;i++)   /*find path for each arrow out of object*/
                {
//    viewbox.append("X check-one-one; arrow number " + i + "\n");
                objects[domain]++;              /*increment number of times object has been visited*/
                current_arrow = arrow_array[i];
                for((j=path_len(path)+1);j>0;j--)       /*get current arrow and add to path*/
                        {
                        path[j] = path[j-1];
                        }
                path[0]=current_arrow;
                if(((codom = A.arr[current_arrow][1]) == codomain) && (objects[codom] != maxloop))
      // codomain of current arrow is the test object, so process the path,
      // calling it gamma
                        {
                        gamma = copy_path(gamma,path);
                        reduced_gamma = reduce(reduced_gamma,gamma,A);
                        if (path_len(reduced_gamma) == 0)
        /* if gamma reduces to identity */
                                {
                                reduced_gamma[0] = -2;    /* make a path containing -2 */
                                reduced_gamma[1] = -1;
                                }
                        if(!(t.search_and_add(gammatree,reduced_gamma, path_len(reduced_gamma),tp, theprev, A, viewbox)))
        /* search for, and if necessary add, reduced_gamma to gammatree
           if it was added then also process gamma_alpha and gamma_beta */
                                {
                                gamma = append_path(gamma,alpha);
                                reduced_gammaalpha = reduce(reduced_gammaalpha,gamma,A);
                                if (path_len(reduced_gammaalpha) == 0)
                                        {                               /* if gamma alpha reduces to identity */
                                        reduced_gammaalpha[0] = -2;   /* make path with -2 to represent identity */
                                        reduced_gammaalpha[1] = -1;
                                        }
                                gamma = copy_path(gamma,path);
                                gamma = append_path(gamma,beta);
                                reduced_gammabeta = reduce(reduced_gammabeta,gamma,A);
                                if (path_len(reduced_gammabeta) == 0)
                                        {                              /* if gamma beta reduces to identity */
                                        reduced_gammabeta[0] = -2;   /* make path with -2 to represent identity */
                                        reduced_gammabeta[1] = -1;
                                        }
                                  temptree = t.create_tree(viewbox);
                                t.search_and_add(gamalbet, reduced_gammaalpha, path_len(reduced_gammaalpha),temptree, theprev, A, viewbox);
          /* now add reduced_gamma_alpha to gamalbet if necessary */
         // viewbox.append("X gammalph added - tree is: \n");
         // t.display_tree(gamalbet, viewbox, A);
          if (t.previous.down.tree == null)
                                        {                /* if no subtree for gamma_alpha then create one */
                                        t.previous.down.tree = t.create_tree(viewbox);
                                        }
                                  temptree = t.create_tree(viewbox);
                                  if (t.search_and_add(t.previous.down.tree,reduced_gammabeta, path_len(reduced_gammabeta),temptree, theprev, A, viewbox))
                                        {/* if gamma_beta in subtree for gamma_alpha the pair is not new ...*/
                                        return(false);  /*ie pair of paths already in tree, not 1-1*/
                                        }                 /*exit function and return false*/
          else
          { /* gamma_beta is added... */
//          viewbox.append("X gammabet added - gamalbet tree is: \n");
//          t.display_tree(gamalbet, viewbox, A);
          }
        } // gamma was found in gammatree
      }  // codomain of current arrow was not the test object, so...
      /*keep going along path with codomain of current arrow as new domain*/
      if(!(check_oneone(path,codom,codomain,objects,gamalbet,A,alpha,beta,gammatree,maxloop)))
                        {
//              viewbox.append("X returns 1-1 false, recursed\n");
                          return(false);  /*if not 1-1 exit function*/
      }
                        for(j=1;j<=path_len(path);j++)
                        {
                                path[j-1] = path[j];    /*arrow no longer in path, remove it*/
                        }
                        objects[domain]--;  /*object no longer part of path, decrement visit number*/
    } // i will be incremented, test new arrow
        return(true);   /*1-1, return true*/
  }
  else // too many loops
  {
    new MessageDialog(this, "Error", "Endo limit exceeded, test for one-one fails", true);
  }
   return false;
 }

 void make_homtree(int path[], int domain, int codomain, int objects[], nodetype homtree, Category A, int maxloop)
 /*
 Parameters:
        path:   the current path of arrows
        domain: the current object of the path
        codomain:  the object we are trying to find all arrows to
        objects:   an array of integers which keeps the function from exceeding
                                the maximum number of loops
  homtree:   the first node of the tree of arrows
        A:      the category being tested
 Local Variables:
        number: stores the number of arrows from an object
        current_arrow:  stores the number of the current arrow in the path
        codom:  stores the codomain of the current arrow
        arrow_array:    contains all of the arrows from an object
 Purpose:
        To generate the reduced hom set from one object to another as a tree
 Design:
        Creates a tree homtree of all the reduced paths from one object to another.
 */

 {
  int i,j, number, current_arrow, codom;
  int arrow_array[] = new int [ed.cons.MAXARR];
  int reducedpath[] = new int [ed.cons.MAXWORD];
  nodetype theprev = new nodetype();
  nodetype  pointer = new nodetype();

  if(!(objects[domain] == maxloop))
        {
          number = all_arr(A,domain,arrow_array); /*get all arrows from current object*/
    for(i=0;i<number;i++)   /*find path for each arrow out of object*/
                {
                objects[domain]++;              /*increment number of times object has been visited*/
                current_arrow = arrow_array[i];
                for((j=path_len(path)+1);j>0;j--)       /*get current arrow and add to path*/
                        {
                        path[j] = path[j-1];
                        }
                path[0]=current_arrow;
                if(((codom = A.arr[current_arrow][1]) == codomain) && (objects[codom] != maxloop))   /*if codomain is destination*/
                        {                                               /*object then check 1-1 and store*/
                        reducedpath = reduce(reducedpath,path,A);
                        if (path_len(reducedpath) == 0) /* if path reduces to identity */
                                {
                                reducedpath[0] = -2;    /* make path with -2 to represent identity */
                                reducedpath[1] = -1;
                                }
                          t.search_and_add(homtree,reducedpath, path_len(reducedpath),pointer, theprev, A, viewbox); /* add it to the homtree */
      }
      /*keep going along path with codomain of current arrow as new domain*/
      make_homtree(path,codom,codomain,objects,homtree,A,maxloop);
                        for(j=1;j<=path_len(path);j++)
                        {
                          path[j-1] = path[j];    /*arrow no longer in path, remove it*/
      }
                        objects[domain]--;      /*object no longer part of path, decrement number*/
    }                                               /*of times it has been visited*/
  }
 }

 public boolean check_onto(int path[], int domain, int codomain, int objects[], nodetype gamalbet, Category A, nodetype rhotree, int maxloop)
 /*
 Parameters:
        path:   the current path
        domain: the current object of the path
        codomain:       the object we are trying to find all arrows to
        objects:        an array of integers which keeps the function from exceeding
                                the maximum number of loops
        gamalbet: the first node of a the tree of gamma alphas with gamma betas
        A:      the category being tested
        rho_tree:       a tree of all the rhos
 Local Variables:
        number: stores the number of arrows from an object
        current_arrow:  stores the number of the current arrow in the path
        codom:  stores the codomain of the current arrow
        arrow_array:    contains all of the arrows from an object
 Purpose:
        To check that a sum is onto
 Design:
        Generates all of the lambdas from one object to another and uses the rho tree
        it is passed to check that all of the pairs <lambda,rho> are in our tree.
 */
 {
  int i,j, number, current_arrow, codom;
  int arrow_array[] = new int [ed.cons.MAXARR];
  int reducedpath[] = new int [ed.cons.MAXWORD];
  nodetype node = new nodetype();
  nodetype theprev = new nodetype();

  if(!(objects[domain] == maxloop))
        {
        number = all_arr(A,domain,arrow_array); /*get all arrows from current object*/
        for(i=0;i<number;i++)   /*find path for each arrow out of object*/
                {
                objects[domain]++;              /*increment number of times object has been visited*/
                current_arrow = arrow_array[i];
                for((j=path_len(path)+1);j>0;j--)       /*get current arrow and add to path*/
                        {
                        path[j] = path[j-1];
                        }
                path[0]=current_arrow;
                if(((codom = A.arr[current_arrow][1]) == codomain)     && (objects[codom] != maxloop))
                        {  /*if codomain is destination object then check that lambda-rho in tree*/
                        reducedpath = reduce(reducedpath,path,A);
                        if (path_len(reducedpath) == 0) /* if path reduces to identity */
                                {
                                  reducedpath[0] = -2;   /* make path with -2 to represent identity */
                                  reducedpath[1] = -1;
                                }
                        if(!(t.search_and_add(gamalbet,reducedpath, path_len(reducedpath),node, theprev, A, viewbox)))       /* search for it in gamalbet */
                                {
//          viewbox.append("X path not found\n");
                                return(false);                /* if not in tree, not onto */
                                }
                        else
                                {
                                if(!(t.equal_trees(t.previous.down.tree,rhotree, viewbox)))
          /* if rhotree unequal subtree of reducedpath in gamalbet then some
             pairs not present */
                                        {
//            viewbox.append("X path found, but equaltrees fails\n");
                                        return(false);
                                        }
                                }
      }
      /*keep going along path with codomain of current arrow as new domain*/
      if(!(check_onto(path,codom,codomain,objects,gamalbet,A,rhotree,maxloop)))
                        {
                          return(false);  /*if not onto exit function*/
      }
      for(j=1;j<=path_len(path);j++)
                        {
        path[j-1] = path[j];    /*arrow no longer in path, remove it*/
      }
                        objects[domain]--;      /*object no longer part of path, decrement number*/
    }                                               /*of times it has been visited*/
  }
        return(true);   /*onto, return true*/
 }

public boolean is_sum(Category A, int sumobj, int alpha[], int beta[], int maxloop)
 /*
 Parameters:
        A:      pointer to the category being tested
        sumobj: the object of the sum being tested
        alpha:  first injection of the sum
        beta:   second injection of the sum
 Local Variables:
  testobj: is currently being tested for sum property
        path:    keeps track of the current path to testobj from sumobj
        objects: array of integers storing the number of times each object has
           been visited in current path
        id:      a path that has a value of -2 and represents the identity arrow
        gammatree: tree of all arrows from sumobj to testobj
        gamalbet: tree of gamma alphas with gamma beta subtrees
        rhotree: tree of all arrows from domain of beta to testobj
        p, tp:   temporary pointers
  reduced_alpha, reduced_beta : normalized versions of the injections

 Purpose:
        To check each object in the category for 1-1 and onto.
 Design:
        Returns true if object is a sum, and false if not.
 */
 {
  int testobj,j;
  int path[] = new int[ed.cons.MAXWORD];
  int objects[] = new int[ed.cons.MAXWORD];
  int id[] = new int[ed.cons.MAXWORD];
  int dom;
  int reduced_alpha[] = new int[ed.cons.MAXWORD];
  int reduced_beta[] = new int[ed.cons.MAXWORD];
  nodetype gamalbet = new nodetype();
  nodetype rhotree = new nodetype();
  nodetype theprev = new nodetype();
  nodetype p = new nodetype();
  nodetype tp = new nodetype();
  nodetype temptree = new nodetype();
  nodetype gammatree = new nodetype();;
  listnodetype l = new listnodetype();
  listnodetype list = new listnodetype();
  listnodetype gammalist = new listnodetype();

  for (testobj=0;testobj<A.numobj;testobj++)
        { /* for each object in category*/
//    viewbox.append("\n X -----------\ntest obj = " + A.obj[testobj] + "\n-----------\n\n");
    /*initialize path and objects*/
                path[0] = -1;
                for (j=0;j<A.numobj;j++)
        {
                        objects[j] = 0;
                }
                id[0] = -2;
                id[1] = -1;
                gamalbet = t.create_tree(viewbox);
                gammatree = t.create_tree(viewbox);
                if(testobj == sumobj)
                { /* identity is a gamma so add alpha and beta to gamalbet */
      reduced_alpha = reduce(reduced_alpha, alpha, A);
      reduced_beta = reduce(reduced_beta, beta, A);
                        t.search_and_add(gamalbet,reduced_alpha, path_len(reduced_alpha),p,theprev,A, viewbox);
      if (t.previous.down.tree == null) //here it surely ought to be !!
                                {           /* if no subtree for this gamma_alpha then create one */
//            viewbox.append("previous.down.tree is null \n");
                                        t.previous.down.tree = t.create_tree(viewbox);
                                }
      temptree = t.create_tree(viewbox);
      t.search_and_add(t.previous.down.tree,reduced_beta, path_len(reduced_beta),temptree, theprev, A, viewbox);
//      viewbox.append("X gamalbet \n");
//      t.display_tree(gamalbet, viewbox, A);

      /* ...and add identity to tree  of gammas */
      t.search_and_add(gammatree,id, path_len(id),p,theprev,A, viewbox);
                }
    if(!(check_oneone(path,sumobj,testobj,objects,gamalbet,A,alpha,beta,gammatree,maxloop)))
                {
//      viewbox.append(" X gammatree\n");
//      t.display_tree(gammatree, viewbox, A);
      viewbox.append("Too many pairs for object " + A.obj[testobj] + "\n");
                        return(false);
                }
                else
    /* passed check one-one for test object  */
                {
//      viewbox.append("passed check one-one for test object \n");
//      viewbox.append("X gamalbet \n");
//      t.display_tree(gamalbet, viewbox, A);
//      viewbox.append("X gammatree\n");
//      t.display_tree(gammatree, viewbox, A);
      /* re-initialize path and objects */
                        path[0] = -1;
                        for (j=0;j<A.numobj;j++)
                        {
                        objects[j] = 0;
                        }
                        rhotree = t.create_tree(viewbox);
                        if(path_len(beta) == 0)      /* if beta is the identity */
                        {
                                dom = sumobj;             /* domain of beta is sum object */
                        }
                        else
                        {
                                dom = A.arr[beta[path_len(beta)-1]][0]; /* domain of beta is domain
                                                                                                of first arrow in path   */
                        }
      /* store all rhos in a tree */
                        make_homtree(path,dom,testobj,objects,rhotree,A,maxloop);
//      viewbox.append("X rhotree\n");
//      t.display_tree(rhotree, viewbox, A);
                        if (dom == testobj)   /* if domain of beta is destination object */
                        {
                                t.search_and_add(rhotree,id, path_len(id),tp,theprev,A, viewbox);  /* add identity to rhotree */
                        }
      /* re-initialize path and objects */
                        path[0] = -1;
                        for (j=0;j<A.numobj;j++)
                        {
                                objects[j] = 0;
                        }
                        if(path_len(alpha) == 0)    /* if alpha is identity */
                {
                                dom = sumobj;            /* domain of alpha is sum object */
                        }
                        else
                        {
                                dom = A.arr[alpha[path_len(alpha)-1]][0];
        /* domain of alpha is domain of first arrow in alpha   */
                        }
                        if (rhotree.down != null)
      /* if rhotree is not empty check for onto */
      {
                                if (dom == testobj)    /* if domain of alpha is test obj. */
                                {
                                                                                                   /* check to see that identity is */
                                if(!(t.search_and_add(gamalbet,id, path_len(id),tp, theprev, A,viewbox)))  /* in gamalbet; if not, then not onto   */
                                        {
            /* identity on domain alpha is not in gamalbet - not onto */
                                                return(false);
                                        }
                                        else
          /* identity is in gamalbet */
                                        {
                                                if(!(t.equal_trees(rhotree,tp.tree, viewbox)))
            /* check that rhotree equals subtree of identity in gamalbet  */
            /* if not, then not onto */
                                                {
             // viewbox.append("X equal_trees subtree of identity domain alpha is false");
                                                        return(false);
                                                }
                                        }
                                }
                                if (!(check_onto(path,dom,testobj,objects,gamalbet,A,rhotree,maxloop)))
                                {
          viewbox.append("Not enough pairs for object " + A.obj[testobj] + "\n");
                                        return(false);        /* if not onto, then not a sum */
                                }
                        }
//          viewbox.append("rhotree is empty\n");
                }
        }
  return(true);
 }

 //Global Variables needed for Sum option in category Tools
 String objchr;
 int alpha[] = new int [ed.cons.MAXWORD];
 int beta[] = new int [ed.cons.MAXWORD];
 int obj;
  TextField categoryField = new TextField();
  Label categoryLabel = new Label();
  TextArea viewbox = new TextArea("", 10, 10, TextArea.SCROLLBARS_VERTICAL_ONLY);
  Button sumButton = new Button();
  TextField alphaField = new TextField();
  TextField betaField = new TextField();




 public void sum(Category A)
 /*
 Parameter:
        A:      category being tested
 Purpose:
        To get user input about sum to be tested.
 Design:
        Gets user input and then calls function is_sum to test sum
 */
 {
   String alphapath, betapath;

    if (editoption == 0)
    {
      objchr = objectChoice.getSelectedItem();
      //viewbox.append(workbox.getText() + "\n\n");
      if(check_obj(objchr,A))
                  {
                          viewbox.append("\n********ERROR********\n");
                          viewbox.append(objchr + " is not an object of " + A.name + ".\n");
                          viewbox.append("***********************\n\n");
        //viewbox.append("Object of Sum:");
                  }
      else
      {
        editoption = 1;
        obj = object_number(objchr,A);
        //viewbox.append("Enter alpha: ");
      }
    }
    if (editoption == 1)
    {
        alphapath = alphaField.getText();
        //viewbox.append(workbox.getText() + "\n\n");
        if (!(check_string(alphapath,A)))
        {
          //viewbox.append("Enter alpha: ");
        }
        else
        {
          alpha = copy_path(alpha,string_to_path(alphapath,A));
          if (!(check_path(alpha,A)))
          {
            //viewbox.append("Enter alpha: ");
          }
          else
          {
            if (A.arr[alpha[0]][1] != obj)
                              {
                                       viewbox.append("\nAlpha must have codomain of " + A.obj[obj] + "\n\n");
                                       //viewbox.append("Enter alpha: ");
            }
            else
            {
             editoption = 2;
             //viewbox.append("Enter beta: ");
            }
          }
      }
    }
    if (editoption == 2)
    {
        betapath = betaField.getText();
              //viewbox.append(workbox.getText() + "\n\n");
        if (!(check_string(betapath,A)))
        {
                        //viewbox.append("Enter beta: ");
        }
            else
        {
          beta = copy_path(beta,string_to_path(betapath,A));
                            if (!(check_path(beta,A)))
                            {
                        //viewbox.append("Enter beta: ");
                            }
                            else
          {
            if (A.arr[beta[0]][1] != obj)
                              {
                                viewbox.append("\nBeta must have codomain of " + A.obj[obj] + "\n");
                         //viewbox.append("\nEnter beta: ");
            }
            else
            {
                if (is_sum(A,obj,alpha,beta,ed.cons.maxloop))
                      {
                          viewbox.append("\n" + A.obj[obj] + " is a sum.\n");
                      }
                    else
                    {
                          viewbox.append("\n" + A.obj[obj] + " is not a sum.\n");
                    }
                //menuoption = 0;
                editoption = 0;
            }
          }
        }
    }
 }

   public int[] copy_path(int dest[], int source[])
  /*
  Parameters:
        dest:   an array of integers which will be set to equal source
        source: an array of integers which is copied into dest
  Purpose:
        To copy one array of integers to another array of integers
  Design:
        Copies source into dest
  */
  {
    int i;
    int temp[] = new int [ed.cons.MAXWORD];

    for(i=0;i<=path_len(source);i++)
    {
      temp[i] = source[i];
    }
    return(temp);
  }


public int path_len(int path[])
 /*
 Parameters:
        path:   an array of integers terminated by -1 which is a path
 Purpose:
        To determine the length of an array of integers terminated by -1
 Design:
        Returns the number of integers in the path, does not count -1
 */
 {
        int length = 0;
        while (path[length] != -1)
        {
        length++;
        }
  return(length);
 }

 public int all_arr(Category C,int i,int a[])
 /*
 Parameters:
        C:      pointer to the current category
        i:      integer representing an object in the category
        a:      array containing all arrows with object i as their domain
 Purpose:
        Returns an integer whose value is the number of arrows in the category
        with object i as their domain.  The array a is passed back containing
        all such arrows.
 */
 {
        int j,k=0;

        for (j=0;j<C.numarr;j++)
                if (C.arr[j][0] == i)
                {
                        a[k] = j;
                        k++;
                }
        return(k);
 }

 public int[] append_path(int dest[], int source[])
 /*
 Parameters:
        dest:   an array of integers is appended to this array of integers
        source: this array of integers is appended to dest
 Purpose:
        To append one array of intgers to another array of integers, all terminated
        by -1
 Design:
        Appends source to dest
 */
 {
  int i, size;

  size = path_len(dest);
  for(i=0;i<=path_len(source);i++)
  {
          dest[size+i] = source[i];
        }
  return (dest);
 }

 int[] string_to_path(String st, Category c)
 /*
 Parameters:
        st:     the string that we want to convert to an array of integers terminated
                by -1
        A:      a category that contains the arrows of the string
 Purpose:
        To convert a string of characters, where the characters represent arrows, into
        an array of integers, terminated by -1, where the integers represent arrows.
 Design:
        Returns an array of integers terminated by -1, and does not change the st.
 */
 {
  int i;
  int temp[] = new int [ed.cons.MAXWORD];

  if(st.length() == 0)
  {
    temp[0] = -1;
    return(temp);
  }
  else
  {
    String[] arr = new String[ed.cons.MAXARR];
    int arrnum = 0;
    int prev = 0;

    for(i=0;i<st.length();i++)
    {
      //displayArea.setText(arrows);
      if ((st.charAt(i) == '*'))
      {
        arr[arrnum] =  st.substring(prev, i);
        temp[arrnum]= arrow_number(arr[arrnum], c);
        prev = i+1;
        arrnum++;
      }
      else if (i == (st.length()-1))
      {
        arr[arrnum] =  st.substring(prev, i+1);
        temp[arrnum]= arrow_number(arr[arrnum], c);
        prev = i+1;
        arrnum++;

      }

    }
    temp[arrnum] = -1;
    i=0;
    while (temp[i] != -1)
    {
        i++;
    }
    return(temp);
  }
 }

 boolean check_path(int path[], Category A)
 /*
 Parameters:
        path: the path to be checked
        A: the current category
 Purpose:
        To check that the domains and codomains of all the arrows in the path
        match up
 Design:
        Checks that all the domains and codomains of the arrows in the path match
        up and returns true if this is the case and false otherwise
 */
 {
  int i,arr,nextarr;

  for (i=0;i<(path_len(path)-1);i++)
  {
     arr = path[i];
     nextarr = path[i+1];
     if ((A.arr[arr][0]) != (A.arr[nextarr][1]))
     {
          new MessageDialog(this, "Error", "Invalid Composition. Domain of " + A.arrow[arr] + " does not equal codomain of " + A.arrow[nextarr], true);
     }
  }
  return(true);
 }

  public boolean check_string(String str, Category c)
  //This function is designed to verify that all arrows in the str are
  //valid arrows of the category c. For each arrow of the string checks
  //that it exists in the category c. Returns true if this is the case
  //and false otherwise. The parameter str is the string to check and the
  //parameter c is the current category
  {
    int i;

    //for (i=0;i<c.numarr; i++)
    String[] arr = new String[MAXARR];
    int arrnum = 0;
    int prev = 0;
    //displayArea.setText(arrows);
    for (i=0;i<str.length();i++)
    {
      if ((str.charAt(i) == '*'))
      {
        arr[arrnum] =  str.substring(prev, i);
        if (check_arr(arr[arrnum], c))
        {
          new MessageDialog(this, "Error", str + " is not an arrow of " + c.name, true);
          return(false);
        }
        prev = i+1;
        arrnum++;
      }
      else if (i == (str.length()-1))
      {
        arr[arrnum] =  str.substring(prev, i+1);
        if (check_arr(arr[arrnum], c))
        {
          new MessageDialog(this, "Error", str + " is not an arrow of " + c.name, true);
          return(false);
        }
        prev = i+1;
        arrnum++;
      }
    }
    return(true);
  }

 public int object_number(String name, Category B)
 /*
 Parameters:
        name:   the name of the object that we want the integer value of
        A       :       the category that contains the object
 Purpose:
        To get the integer representation for the character representation of an
        object
 Design:
        Returns the integer value of an object, -1 if the object is not in the
        category
 */
 {
  int i;

  for(i=0; i < B.numobj;i++)
        {
        if(B.obj[i].equals(name))
                {
      return(i);
                }
        }
  return(-1);
 }

  public int[] reduce(int reducedpath[], int path[], Category c)
 /*
 Parameters:
        reducedpath:    an array of integers which will be set to equal the
                                        reduced path
        path:                   the array of integers being reduced
        A       :                       a category
 Purpose:
        To reduce a path using the set of relations stored in a category
 Design:
        Reduces path and stores its reduced form in reducedpath
*/
 {
  int i,j;
  int spot; //the spot where the left side of a relation begins in the path being
                  //reduced
  int temp; //a temporary variable used to store the length of a path
  int diff; //the difference in length between the left side of a relation and the
              //right side of the relation

        reducedpath = copy_path(reducedpath,path);
        for (i=0;i<c.num_rel;i++)
        {
                if((spot = search(c.rel_set[i].lhs,reducedpath,0)) != -1)
                {
      for (j=spot;j<spot+path_len(c.rel_set[i].rhs);j++)
                        {

                                reducedpath[j] = c.rel_set[i].rhs[j - spot];
                        }
      //viewbox.append("reducedpath[i] = " + reducedpath[i]  + "\n");
                        temp = path_len(reducedpath);
                        diff = path_len(c.rel_set[i].lhs) - path_len(c.rel_set[i].rhs);
                        for (j=spot+path_len(c.rel_set[i].lhs);j<temp;j++)
                        {
                                reducedpath[j - diff] = reducedpath[j];
                        }
                        reducedpath[j - diff] = -1;
                        i = -1;
    }
        }
  return(reducedpath);
 }

 public boolean check_obj(String obj, Category x)
 /*
 Parameters:
        obj:    the name of the object being checked
        A  :    the category
 Purpose:
        To determine whether an object is in the category.
 Design:
        Returns false if the object is in the category and true if it is not
 */
 {
  int i;

        for(i=0;i < x.numobj;i++)
        {
                if(obj.equals(x.obj[i]))
                {
                        return(false);
                }
        }
        return(true);
 }


  public boolean check_arr(String arr, Category c)
 /*
 Parameters:
        arr:    the name of the arrow being checked
        A  :    the category
 Purpose:
        To determine whether an arrow is in the category
 Design:
        Returns false if the arrow is in the category and true if it is not
 */
 {
  int i;

        for(i=0;i<c.numarr;i++)
        {
      if(arr.equals(c.arrow[i]))
                        {
                               return(false);
                        }
  }
        return(true);
 }

 public int arrow_number(String name, Category c)
 {
  int i;

  for(i=0;i < c.numarr;i++)
  {
        if(c.arrow[i].equals(name))
    {
     //viewbox.append("    Arrow Num: " + i + "(" + c.arrow[i] + ")\n");
                 return(i);
        }
  }
  return(-1);
 }

  public int search(int sub[], int target[], int start)
 /*
 Parameters:
        sub:    an array of integers which is the subpath we are looking for
        target: an array of integers which is being searched for sub
        start:  The place in target where the search is to begin
 Purpose:
        To search one path, begining at some starting position, to see if another
        path is a subpath
 Design:
        Returns the position where the subpath begins in the path being searched,
         and -1 if sub is not a subpath of target
 */
 {
  int i,j;
  boolean found;

  found = false;
        for (i=start;i<path_len(target);i++)
  {
                if (sub[0] == target[i])
                {
                        found = true;
                        for (j=0;j<path_len(sub);j++)
                        {
                                if (target[i+j] != sub[j])
                                {
                                        found = false;
                                }
                        }
                }
                if (found)
                {
                                break;
                }
        }
  if (found)
        {
          return(i);
  }
        else
        {
                return(-1);
        }
 }
 /*
  void objectChoice_itemStateChanged(ItemEvent e)
  //This function occurs when a new object is selected from the list. When this
  //occurs, the arrows with the appropriate codomains are placed in the alpha and
  //beta choice menus
  {
    alphaChoice.removeAll();
    betaChoice.removeAll();
    for (int i = 0; i < ed.cat.numarr; i++)
    {
      if (ed.cat.obj[ed.cat.arr[i][1]].equals(objectChoice.getSelectedItem()))
      {
          alphaChoice.addItem(ed.cat.arrow[i] + ":" + ed.cat.obj[ed.cat.arr[i][0]] + "->" + ed.cat.obj[ed.cat.arr[i][1]]);
          betaChoice.addItem(ed.cat.arrow[i] + ":" + ed.cat.obj[ed.cat.arr[i][0]] + "->" + ed.cat.obj[ed.cat.arr[i][1]]);
      }
    }
    if (alphaChoice.countItems() == 0 || betaChoice.countItems() == 0)
    {
      String e1 = "Error\nCan not Perform Sum\nCategory has 0 Arrows with Codomain " + objectChoice.getSelectedItem();
      error_message(e1);
    }

  }

  void alphaChoice_itemStateChanged(ItemEvent e) {

  }

  void betaChoice_itemStateChanged(ItemEvent e) {

  }*/

  /*String[] parseArrows(String arrows)
  {
    String[] arr = new String[ed.MAXARR];
    int arrnum = 0;
    int prev = 0;
    //displayArea.setText(arrows);
    for (int i =0; i < arrows.length(); i++)
    {
      if ((arrows.charAt(i) == '*') || (i == (arrows.length()-1)))
      {
        arr[arrnum] =  arrows.substring(prev, i);
        prev = i+1;
        arrnum++;
      }
    }
  }*/
}

