/*
Research Project:   Category Theory Database Tools
                    J. Bradbury, Dr. R. Rosebrugh
                    Mount Allison University 1999
File:               InitialObjectFrame.java
Description:	      This file is displayed when the user selects the "Initial
                    Object" menu option in the main window. The user
                    can select a category file(*.CAT) from a choice menu and then
                    chose to check if one or all of the categories are intial.
                    The information on each object tested will be displayed in
                    the text area.
*/

//import statements
import java.awt.*;
import borland.jbcl.layout.*;
import java.awt.event.*;
import borland.jbcl.control.*;

public class TerminalObjectFrame extends Frame
{
  Category cat = new Category();
  DefList l = new DefList();
  int check_enter = 0;

  //Constants
  Constants cons = new Constants();
  int maxloop = cons.maxloop;
  int MAXWORD = cons.MAXWORD;
  int MAXARR = cons.MAXARR;

  //Objects in the Graphical User Interface(GUI)
  Button exit = new Button();
  Panel button_panel = new Panel();
  BorderLayout borderLayout1 = new BorderLayout();
  XYLayout xYLayout1 = new XYLayout();
  Button okButton = new Button();
  Button checkButton = new Button();
  Choice categoryChoice = new Choice();
  Label label2 = new Label();
  TextArea textArea1 = new TextArea("", 10, 10, TextArea.SCROLLBARS_VERTICAL_ONLY);
  MainWindow edit = new MainWindow();
  List objectList = new List();
  Label label1 = new Label();
  Button selectAllButton = new Button();
  TextField currentCategory = new TextField();

  public TerminalObjectFrame(DefList ltemp, MainWindow ed)
  //Default Constructor with the list of categories and the ok
  //button as parameters
  {
    //l = ltemp;
    edit = ed;
    try  {
      jbInit();
    }
    catch (Exception e) {
      e.printStackTrace();
    }
  }

  public boolean handleEvent(Event e)
  {
    if ((e.id == Event.WINDOW_DESTROY) || (e.id == Event.ACTION_EVENT))
    {
     hide();            //hide frame
     dispose();         //free resources
     return true;
    }
    else if (e.key == Event.ENTER)
    {
      if (check_enter == 0)
       check_enter++;
      else
      {
       hide();            //hide frame
       dispose();         //free resources
      }
      return true;
    }
    return super.handleEvent(e);
  }

  public boolean action(Event e, Object o)
  {
    if ((e.target == exit) || (e.key == Event.ENTER))
    {
      hide();            //hide frame
      dispose();         //free resources
      return true;
    }
    return false;
  }

  private void jbInit() throws Exception
  //This function intializes the GUI
  {
    this.setTitle("GDCT: Check Category for Terminal Object(s)");
    this.setBackground(new Color(192,192,192));
    xYLayout1.setHeight(284);
    okButton.setLabel("OK");
    xYLayout1.setWidth(485);
    okButton.setLabel("OK");
    okButton.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        okButton_actionPerformed(e);
      }
    });
    checkButton.setLabel("Check Object(s)");
    /*categoryChoice.addItemListener(new java.awt.event.ItemListener() {
      public void itemStateChanged(ItemEvent e) {
        categoryChoice_itemStateChanged(e);
      }
    });*/
    label2.setText("Current Category:");
    this.setLayout(xYLayout1);
    currentCategory.setBackground(Color.white);
    objectList.setBackground(Color.white);
    this.add(okButton, new XYConstraints(367, 216, 94, 31));
    this.add(checkButton, new XYConstraints(266, 217, 93, 31));
    //this.add(categoryChoice, new XYConstraints(348, 251, 143, -1));
    this.add(label2, new XYConstraints(8, 6, -1, 25));
    this.add(textArea1, new XYConstraints(162, 10, 298, 197));
    this.add(objectList, new XYConstraints(9, 90, 138, 159));
    this.add(label1, new XYConstraints(7, 61, -1, -1));
    this.add(selectAllButton, new XYConstraints(163, 217, 95, 31));
    this.add(currentCategory, new XYConstraints(7, 35, 141, 26));

   // ListNode current = l.head;
   // while(current != null)
   // {
    //  categoryChoice.addItem(current.cat.name);
    //  current = current.next;
    //}
    textArea1.setBackground(Color.white);
    String name = categoryChoice.getSelectedItem();
    //cat = l.getNode(name);
    cat = edit.cat;
    currentCategory.setEditable(false);
    currentCategory.setText(cat.name);
    selectAllButton.setLabel("Select All");
    selectAllButton.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        selectAllButton_actionPerformed(e);
      }
    });
    checkButton.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        checkButton_objectList_actionPerformed(e);
      }
    });
    label1.setText("Select Object(s) to Check:");
    //if (name.equals(cat.name))
    //{
      for (int i = 0; i < cat.numobj; i++)
        objectList.addItem("" + cat.obj[i]);
      if (objectList.countItems() == 0)
      {
        new MessageDialog(this, "Error", "Cannot test if terminal object(s) exist, category has 0 objects", true);
      }
    //}
    objectList.setMultipleSelections(true);
    objectList.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        checkButton_objectList_actionPerformed(e);
      }
    });
    makeDual();
  }

  void okButton_actionPerformed(ActionEvent e)
  //Function called when OK button is pressed. This function
  //take the string in the nameField and makes it the name of
  //the current category
  {
      /*l.replaceNode(c);
      t.displayArea.setText("");
      //Clear graphical display HERE
      t.displayCategory(c, t.displayArea);
      t.GraphCategory(t.graph_, t.graphCanvas_, c);*/
      hide();
      dispose();
  }

/*  void categoryChoice_itemStateChanged(ItemEvent e)
  //When an item in the categoryChoice pulldown menu is seleceted
  //this function is called
  {
    String name = categoryChoice.getSelectedItem();
    cat = l.getNode(name);
    //Call confluence
    objectList.clear();
    if (name.equals(cat.name))
    {
      for (int i = 0; i < cat.numobj; i++)
        objectList.addItem("" + cat.obj[i]);
      if (objectList.countItems() == 0)
      {
        String e1 = "Error\nCan not Test if Initial Object(s) exist\nCategory has 0 Objects";
        error_message(e1);
      }
    }
    else
    {
      String e1 = "Error\nInvalid\nCategory has been selected";
      error_message(e1);
      hide();
      dispose();
    }
    edit.cat = cat;
    //Clear graphical display HERE
    edit.displayCategory(edit.cat);
    edit.GraphCategory(edit.graph_, edit.graphCanvas_, edit.cat);
  } */

  void selectAllButton_actionPerformed(ActionEvent e)
  //This function selects all objects
  {
    for (int i=0; i < objectList.getItemCount(); i++)
      objectList.select(i);
  }

  void checkButton_objectList_actionPerformed(ActionEvent e)
  {
    textArea1.setText("");
    for (int i = 0; i < objectList.getItemCount(); i++)
    {
      try
      {
        int editsub = 0;
        String temp = objectList.getSelectedItems()[i];
        editsub = object_number(temp, cat);
        int start = editsub;
        int end = editsub + 1;
        initial_object(maxloop, start, end);
      }
      catch (ArrayIndexOutOfBoundsException aie)
      {
      }
    }
    for (int i=0; i < objectList.getItemCount(); i++)
      objectList.deselect(i);
    textArea1.setCaretPosition(0);
  }

 //INITIAL OBJECT FUNCTIONS

 public boolean check_initial(int path[], int domain, int objects[], int object_array[][], String orig, int maxloop)
 /*
 Parameters:
        path:   array of integers containing the path of arrows followed
                                        so far
        domain: integer representing the domain of the current arrow in
                                        the path
        objects:array of integers containing the objects visited along
                                        the current path
        object_array:   uses the integers representing the objects as subscripts
                                        and stores paths to each object as the elements of the
                                        array
        A:      pointer to the current category
        orig:   a character storing the name of the object being
                                        tested for an initial object

 Purpose:
        A recursive function to determine if object domain is initial.

 Design:
        Traces all paths from object domain.  If a path is the first path
        with its codomain, the path is stored in object_array.  Otherwise,
        the path is compared to the path stored for the object which is the
        codomain; if it is not equal to the stored path, the object is not
        initial, a message is displayed, and the function returns false.
        Otherwise, the function returns true.
 */
 {
  int i,j, number,current_arrow, codomain;
  boolean done;
  int arrow_array[] = new int [MAXARR];
  int first[] = new int [MAXWORD];
  int second[] = new int [MAXWORD];
  int loopcount;


  done = false;
  loopcount = 0;
  for(i=0;i<path_len(objects);i++)
        {
        if(objects[i] == domain)
                {
                loopcount++;
                objects[path_len(objects)+1] = -1;
                objects[path_len(objects)] = domain;
                    if (loopcount == maxloop)
                          {
                             done = true;
                             i = path_len(objects);
        }
    }
  }
  if(!done)
        {
          number = all_arr(cat,domain,arrow_array);
          objects[path_len(objects)+1] = -1;
          objects[path_len(objects)] = domain;
          for(i=0;i<number;i++)
                {
      current_arrow = arrow_array[i];
                for((j=path_len(path)+1);j>0;j--)
                        {
         path[j] = path[j-1];
                        }
      path[0]=current_arrow;
                  codomain = cat.arr[current_arrow][1];
      //viewbox.append(Integer.toString(object_array[codomain][0]) + " " + Integer.toString(codomain));
      if(object_array[codomain][0] == -1)
                        {
        int temp[] = new int [MAXARR];
        for (int x = 0; x < MAXARR; x++)
            temp[x] = object_array[codomain][x];
        temp = copy_path(temp,path);
        for (int x = 0; x < MAXARR; x++)
            object_array[codomain][x] = temp[x];

                        }
      else
                        {
          if(object_array[codomain][0] == -2)
                      {
             first = reduce(first,path, cat);
                                     if(first[0]!= -1)
                                           {
                                               textArea1.append("\n" + orig + " NOT TERMINAL...\n" + path_to_string(path, cat));
                                               textArea1.append(" and 1 are both paths from object " + cat.obj[codomain] + "\n");
                                               return(false);
             }
          }
          else
                                        {
             int temp[] = new int [MAXARR];
             for (int x = 0; x < MAXARR; x++)
                 temp[x] = object_array[codomain][x];
             first = reduce(first,temp, cat);
                                           second = reduce(second,path,cat);
                                           if(!equals(first,second))
                                                 {
                                         textArea1.append("\n" + orig + " NOT TERMINAL...\n" + path_to_string(path, cat));
                 for (int x = 0; x < MAXARR; x++)
                      temp[x] = object_array[codomain][x];
                 textArea1.append(" and " + path_to_string(temp, cat) + " are both paths from object " + cat.obj[codomain] + "\n");
                 return(false);
             }
          }
      }
      if(check_initial(path, codomain, objects, object_array, orig, maxloop))
                        {
                            for(j=1;j<=path_len(path);j++)
                                  {
             path[j-1] = path[j];
          }
                            objects[path_len(objects)-1] = -1;
      }
                  else
                        {
                            return(false);
                        }
                }
  }

  return(true);
}

 public void initial_object(int maxloop, int start, int end)
 /*
 Parameter:
        A:      the current category
 Purpose:
        To ask the user for an object in the category and to display a message
        indicating whether or not the object is initial.
 Design:
        Asks the user for an object to be tested.  Calls function check_initial
        to determine if the object has more than one path to any other object;
        if so, the object is not initial.  If there is no path to any object
        in the category, the object is not initial and a message is displayed.
        If there is exactly one path to ALL objects, it is displayed that the
        object is initial.
 */
 {
  int path[] = new int [MAXWORD];
  int objects[] = new int [MAXWORD];
  int objt, i;
  int object_array[][] = new int [MAXWORD][MAXARR];
  char name;
  char ob;

  for (objt=start; objt < end; objt++)
        {
        path[0] = -1;
              objects[0] = -1;
        for(i=0; i < cat.numobj; i++)
        {
                 object_array[i][0] = -1;
        }
                    object_array[objt][0] = -2;
                    if(check_initial(path,objt,objects,object_array,cat.obj[objt],maxloop))
                    {
             for(i=0; i < cat.numobj; i++)
                                     {
                if(object_array[i][0] == -1)
                {
                                                textArea1.append("\n" + cat.obj[objt] + " NOT TERMINAL...\nno path from object " + look_obj(cat,i) + "\n");
                                                  break;
                }
             }
                               if(i== cat.numobj)
                                     {
                textArea1.append("\n" + cat.obj[objt] + " is a terminal object!!\n");
             }
        }
  }
 }

 public String look_obj(Category C,int i)
 /* Returns object #i in the Category C */
 {
        return(C.obj[i]);
 }

 public int all_arr(Category C,int i,int a[])
 /*
 Parameters:
        C:      pointer to the current category
        i:      integer representing an object in the category
        a:      array containing all arrows with object i as their domain
 Purpose:
        Returns an integer whose value is the number of arrows in the category
        with object i as their domain.  The array a is passed back containing
        all such arrows.
 */
 {
        int j,k=0;

        for (j=0;j<C.numarr;j++)
                if (C.arr[j][0] == i)
                {
                        a[k] = j;
                        k++;
                }
        return(k);
 }



  public int path_len(int path[])
  /*
  Parameters:
        path:   an array of integers terminated by -1 which is a path
  Purpose:
        To determine the length of an array of integers terminated by -1
  Design:
        Returns the number of integers in the path, does not count -1
  */
  {
    int length = 0;

    if ((path[0] == cons.id_code) && (path[1] == -1))
      return(0);

    while (path[length] != -1)
    {
      length++;
    }
    return(length);
  }

 public int object_number(String name, Category B)
 /*
 Parameters:
        name:   the name of the object that we want the integer value of
        A       :       the category that contains the object
 Purpose:
        To get the integer representation for the character representation of an
        object
 Design:
        Returns the integer value of an object, -1 if the object is not in the
        category
 */
 {
  int i;

  for(i=0; i < B.numobj;i++)
        {
        if(B.obj[i].equals(name))
                {
      return(i);
                }
        }
  return(-1);
 }

 public int[] copy_path(int dest[], int source[])
 /*
 Parameters:
        dest:   an array of integers which will be set to equal source
        source: an array of integers which is copied into dest
 Purpose:
        To copy one array of integers to another array of integers
 Design:
        Copies source into dest
 */
 {
  int i;
  int temp[] = new int [MAXWORD];

  for(i=0;i<=path_len(source);i++)
        {
        temp[i] = source[i];
  }
  return(temp);
 }

 /*
Parameters:
	path:   the path to be converted to a string(function does not change
			 path)
	A:              a category that contains the arrows of the path
Purpose:
	To convert an array of integers, which represent arrows, terminated by -1
	into a path which is a string of characters which are arrows and the string
	is terminated by \0.
Design:
	Returns a string which is the path represented by the integers in the
	integer array
*/
  String path_to_string(int path[], Category A)
  {
  int i;
  String temp = new String();

  if(path_len(path) == 0)
	{
	  return("1");
	}
  else
	{
	  for(i=0;i<path_len(path);i++)
	  {
      if (i < path_len(path)-1)
  		  temp = temp + A.arrow[path[i]] + "*";
      else
  		  temp = temp + A.arrow[path[i]];

    }
	  //temp = temp + '\0';
	  return(temp);
  }
}

 public int[] reduce(int reducedpath[], int path[], Category c)
 /*
 Parameters:
        reducedpath:    an array of integers which will be set to equal the
                                        reduced path
        path:                   the array of integers being reduced
        A       :                       a category
 Purpose:
        To reduce a path using the set of relations stored in a category
 Design:
        Reduces path and stores its reduced form in reducedpath
*/
 {
  int i,j;
  int spot; //the spot where the left side of a relation begins in the path being
                  //reduced
  int temp; //a temporary variable used to store the length of a path
  int diff; //the difference in length between the left side of a relation and the
              //right side of the relation

        reducedpath = copy_path(reducedpath,path);
        for (i=0;i<c.num_rel;i++)
        {
                if((spot = search(c.rel_set[i].lhs,reducedpath,0)) != -1)
                {
      for (j=spot;j<spot+path_len(c.rel_set[i].rhs);j++)
                        {

                                reducedpath[j] = c.rel_set[i].rhs[j - spot];
                        }
      //viewbox.append("reducedpath[i] = " + reducedpath[i]  + "\n");
                        temp = path_len(reducedpath);
                        diff = path_len(c.rel_set[i].lhs) - path_len(c.rel_set[i].rhs);
                        for (j=spot+path_len(c.rel_set[i].lhs);j<temp;j++)
                        {
                                reducedpath[j - diff] = reducedpath[j];
                        }
                        reducedpath[j - diff] = -1;
                        i = -1;
    }
        }
  return(reducedpath);
 }

 public int search(int sub[], int target[], int start)
 /*
 Parameters:
        sub:    an array of integers which is the subpath we are looking for
        target: an array of integers which is being searched for sub
        start:  The place in target where the search is to begin
 Purpose:
        To search one path, begining at some starting position, to see if another
        path is a subpath
 Design:
        Returns the position where the subpath begins in the path being searched,
         and -1 if sub is not a subpath of target
 */
 {
  int i,j;
  boolean found;

  found = false;
        for (i=start;i<path_len(target);i++)
  {
                if (sub[0] == target[i])
                {
                        found = true;
                        for (j=0;j<path_len(sub);j++)
                        {
                                if (target[i+j] != sub[j])
                                {
                                        found = false;
                                }
                        }
                }
                if (found)
                {
                                break;
                }
        }
  if (found)
        {
          return(i);
  }
        else
        {
                return(-1);
        }
 }

 public boolean equals(int path1[], int path2[])
 /*
 Parameters:
        path1:  an array of integers terminated by -1 which is a path
        path2:  an array of integers terminated by -1 which is a path
 Purpose:
        To determine if two paths are identical
 Design:
        Returns true if path1 is identical to path2 and false otherwise
                note:this function does not reduce them at all
 */
 {
  int i;

  if((path_len(path1)) == (path_len(path2)))
  {
   for(i=0;i<path_len(path1);i++)
   {
                 if(path1[i] != path2[i])
                 {
                        return(false);
                 }
   }
   return(true);
  }
  else
  {
         return(false);
        }
 }


 //Dual Category Methods------------------------------------
   public void makeDual()
  /*
  over, leave:    variables for checking how a person wishes to save their category
  temp2, temp3:   variables for storing temporary paths
  C:      the new category
  */
  {
    char over, leave;
    int i,j,temp;
    int temp2[] = new int [MAXWORD];
    int temp3[] = new int [MAXWORD];
    boolean done;

    Category A = cat;
    Category B = new Category();
    B.name = A.name + "DUAL";

    B.numobj = A.numobj;
    B.numarr = A.numarr;
    B.num_rel = A.num_rel;
    for(i=0;i<A.numobj;i++)
      B.obj[i] = A.obj[i];
    for(i=0;i<A.numarr;i++)
    {
      B.arrow[i] = A.arrow[i];
      B.arr[i][0] = A.arr[i][1];
      B.arr[i][1] = A.arr[i][0];
    }
    for(i=0;i<A.num_rel;i++)
    {
      for(j=path_len(A.rel_set[i].lhs)-1;j>=0;j--)
      {
        temp2[path_len(A.rel_set[i].lhs)-1-j] = A.rel_set[i].lhs[j];
      }
      temp2[path_len(A.rel_set[i].lhs)] = -1;
      for(j=path_len(A.rel_set[i].rhs)-1;j>=0;j--)
      {
        temp3[path_len(A.rel_set[i].rhs)-1-j] = A.rel_set[i].rhs[j];
      }
      temp3[path_len(A.rel_set[i].rhs)] = -1;
      Relation r = new Relation();
      if(greater(temp2,temp3))
      {
        r.lhs = copy_path(r.lhs,temp2);
        r.rhs = copy_path(r.rhs,temp3);
      }
      else
      {
        r.lhs = copy_path(r.lhs,temp3);
        r.rhs = copy_path(r.rhs,temp2);
      }
      B.rel_set[i] = r;
    }
    cat = B;
  }


 public boolean greater(int path1[], int path2[])
 /*
 Parameters:
        path1:  an array of integers terminated by -1
        path2:  an array of integers terminated by -1
 Purpose:
        To determine if path1 has a greater ordering than path2
 Design:
        Returns true if path1 is of greater order than path2
 */
 {
  int j;

        if(path_len(path1) > path_len(path2))
        {
        return(true);
        }
        else
        {
                if ((path_len(path1)) == (path_len(path2)))
                {
                        j = 0;
                        while  (j < path_len(path1))
                        {
                                if (path2[j] > path1[j])
                                {
                                        return(true);
                                }
                                else
                                {
                                        if (path2[j] < path1[j])
                                        {
                                                return(false);
                                        }
                                }
                                j++;
                        }
                }
        }
        return(false);
 }
}
